/******************** (C) COPYRIGHT 2012 MJX ****************************************************************************
* File Name          : main.C
* Author             : MJX
* Version            : V1.20
* Date               : 2015/08/28
* Description        : CH378 USB豸ù̼ģʽӳ
*                      : KEIL 4.10
*    				   MCS51ƬCԵCH378豸ģʽӳ 							 										      
*                      óCH378ģCH378ù̼ģʽͬ豸,2ϴ2´˵;
*                      ͨ´˵´1ݺ, һֱͨϴ˵2شݰ,ٶ;
****************************************************************************************************************************/



/*******************************************************************************/
/* ͷļ */
#include <reg52.h>
#include <stdio.h>
#include <string.h>
#include "CH378INC.H"											 /* CH378ͷļ */	
#include "HAL.H"												 /* Ӳͷļ */
#include "HAL_BASE.C"											 /* Ӳӳļ */
#include "DEBUG.H"												 /* ӳͷļ */
#include "DEBUG.C"												 /* ӳļ */	

/******************************************************************************/
/* ׼豸ṹ */
typedef	union _REQUEST_PACK
{
	UINT8 buf[ 8 ];
	struct
	{
		UINT8 bmRequestType;    	 							 /* ׼ */
		UINT8 bRequest;		   								 	 /*  */
		UINT16 wValue;											 /* ѡ */ 
		UINT16 wIndx;											 /* Ϣ */
		UINT16 wLength;										 	 /* ݳ */
	}req;
} mREQUEST_PACKET;

/******************************************************************************/
/* 豸 */
const UINT8 MyDevDescr[ ] = { 0x12, 0x01, 0x00, 0x02, 0xFF, 0x80, 0x37, 0x40, 
					          0x48, 0x43, 0x38, 0x55,  			 /* IDͲƷID */
						      0x00, 0x01, 0x01, 0x02, 0x00, 0x01 };

/* ȫ */
const UINT8 My_FS_CfgDescr[ ] = { 0x09, 0x02, 0x2E, 0x00, 0x01, 0x01, 0x00, 0x80, 0x32,
						          0x09, 0x04, 0x00, 0x00, 0x04, 0xFF, 0x80, 0x37, 0x00,
						          0x07, 0x05, 0x81, 0x03, 0x40, 0x00, 0x0A,
								  0x07, 0x05, 0x01, 0x02, 0x40, 0x00, 0x00,
								  0x07, 0x05, 0x82, 0x02, 0x40, 0x00, 0x00,
						          0x07, 0x05, 0x02, 0x02, 0x40, 0x00, 0x00 };

/*  */
const UINT8 My_HS_CfgDescr[ ] = { 0x09, 0x02, 0x2E, 0x00, 0x01, 0x01, 0x00, 0x80, 0x32,
						          0x09, 0x04, 0x00, 0x00, 0x04, 0xFF, 0x80, 0x37, 0x00,
						          0x07, 0x05, 0x81, 0x03, 0x40, 0x00, 0x0A,
								  0x07, 0x05, 0x01, 0x02, 0x00, 0x02, 0x00,
								  0x07, 0x05, 0x82, 0x02, 0x00, 0x02, 0x00,
						          0x07, 0x05, 0x02, 0x02, 0x00, 0x02, 0x00 };
								  
/* 豸޶ */
const UINT8	My_QueDescr[ ] = { 0x0A, 0x06, 0x00, 0x02, 0xFF, 0x00, 0xFF, 0x40, 0x01, 0x00 };

/* ȫģʽٶ */
const UINT8	My_FS_OscDescr[ ] = { 0x09, 0x07, 0x2E, 0x00, 0x01, 0x01, 0x00, 0x80, 0x32,
						          0x09, 0x04, 0x00, 0x00, 0x04, 0xFF, 0x80, 0x37, 0x00,
						          0x07, 0x05, 0x81, 0x03, 0x40, 0x00, 0x0A, 
								  0x07, 0x05, 0x01, 0x02, 0x00, 0x02, 0x00,
						          0x07, 0x05, 0x82, 0x02, 0x00, 0x02, 0x00,
						          0x07, 0x05, 0x02, 0x02, 0x00, 0x02, 0x00 };

/* ģʽٶ */
const UINT8	My_HS_OscDescr[ ] = { 0x09, 0x07, 0x2E, 0x00, 0x01, 0x01, 0x00, 0x80, 0x32,
						          0x09, 0x04, 0x00, 0x00, 0x04, 0xFF, 0x80, 0x37, 0x00,
						          0x07, 0x05, 0x81, 0x03, 0x40, 0x00, 0x0A,
								  0x07, 0x05, 0x01, 0x02, 0x40, 0x00, 0x00, 
						          0x07, 0x05, 0x82, 0x02, 0x40, 0x00, 0x00,
						          0x07, 0x05, 0x02, 0x02, 0x40, 0x00, 0x00 };								  								  								  

/*  */
const UINT8 MyLangDescr[ ] = { 0x04, 0x03, 0x09, 0x04 };

/* Ϣ */
const UINT8 MyManuInfo[ ] = { 0x0E, 0x03, 'W', 0, 'C', 0, 'H', 0, '.', 0, 'C', 0, 'N', 0 };

/* ƷϢ */
const UINT8 MyProdInfo[ ] = { 0x14, 0x03, 'C', 0, 'H', 0, '3', 0, '7', 0, '8', 0, 'V', 0, '1', 0, '.', 0, '2', 0 };

/*******************************************************************************/
/*  */
mREQUEST_PACKET USBRequest;									 	 /* USBṹ嶨 */
UINT8  SetupRequest;										 	 /* USB */
UINT16 SetupLength;										 	 	 /* ݳ */
UINT8  *pSetupDescr;									 		 /* ƫƵַ */
UINT8  USBAddress;											 	 /* USBַ */
UINT8  USBSpeed;											 	 /* USBٶ(Ĭ2Ϊ, 0Ϊȫ) */
UINT8  USBConfig;												 /* USBֵ */
UINT8  USBInterCfg;												 /* USBӿ */
UINT8  USBFlag;													 /* USB豸ֲ־,λ0=߸λ,λ1=ȡ豸,λ2=õַ,λ3=ȡ,λ4= */
UINT8  Dev_Buf[ 512 ];
UINT8  USBEndStatus[ 4 ];										 /* USB˵״̬ */
UINT8  Bit_Error_Flag;											 /* ־ */

/* USB豸ֱ־λ */
#define DEF_BIT_USB_RESET               0x01					 /* ߸λ־ */
#define DEF_BIT_USB_DEV_DESC            0x02					 /* ȡ豸־ */
#define DEF_BIT_USB_ADDRESS             0x04					 /* ùַ־ */
#define DEF_BIT_USB_CFG_DESC            0x08	    			 /* ȡ־ */
#define DEF_BIT_USB_SET_CFG             0x10					 /* ùֵ־ */
#define DEF_BIT_USB_WAKE                0x20					 /* USBѱ־ */
#define DEF_BIT_USB_SUPD                0x40					 /* USB߹־ */
#define DEF_BIT_USB_HS                  0x80					 /* USB١ȫٱ־ */

/*******************************************************************************/
/* ѡͨѶӿ */
#define	IC_OP_INTERFACE_MODE	 5							 	 /* оƬӿģʽ(1:Ӳ;  2:ģⲢ; 
                                                                    	                 3:ӲSPI; 4:ģSPI; 5:첽) */                                                                    
#if    ( IC_OP_INTERFACE_MODE == 1 )
#include "../myfile/PARA_HW.C"						 			 /* Ӳ߲ӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 2 )
#include "../myfile/PARA_SW.C"									 /* ģⲢӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 3 )
#include "../myfile/SPI_HW.C"						 			 /* ӲSPIӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 4 )
#include "../myfile/SPI_SW.C"						 			 /* ģSPIʽ */
#elif  ( IC_OP_INTERFACE_MODE == 5 )
#include "../myfile/UART_HW.C"						 			 /* Ӳ첽ӷʽ */
#else
#error: You Must Include Right Interface Operate File!!!
#endif


/*******************************************************************************
* Function Name  : mInitCH378Device
* Description    : ʼCH378豸ģʽ
* Input          : None
* Output         : None
* Return         : ز״̬
*******************************************************************************/
UINT8 mInitCH378Device( void ) 
{
	UINT8  res;

	/* CH378Ƿ */	
	CH378_Port_Init( );  										 /* ӿӲʼ */
	xWriteCH378Cmd( CMD11_CHECK_EXIST );  						 /* ԵƬCH378֮ͨѶӿ */
	xWriteCH378Data( 0x65 );
	res = xReadCH378Data( );
	xEndCH378Cmd( );
	if( res != 0x9A ) 
	{
		/* ͨѶӿڲ,ԭ:ӿ쳣,豸Ӱ(ƬѡΨһ),ڲ,һֱڸλ,񲻹 */
		return( ERR_USB_UNKNOWN );  
	}
	USBSpeed = USB_DEV_SPEED_HS;								 /* ĬٶΪ */	

#ifdef	UART_WORK_BAUDRATE
	/* CH378ͨŲ */
	xWriteCH378Cmd( CMD31_SET_BAUDRATE );  						 /* ôͨѶ */
	xWriteCH378Data( (UINT8)UART_WORK_BAUDRATE );
	xWriteCH378Data( (UINT8)( UART_WORK_BAUDRATE >> 8 ) );
	xWriteCH378Data( (UINT8)( UART_WORK_BAUDRATE >> 16 ) );
	xEndCH378Cmd( );  											 /* 첽ڷʽҪ */

	/* õƬͨŲ */
	mDelaymS( 3 );  
	Set_MCU_BaudRate( );  										 /* ƬлʽͨѶ */

	/* ͨȡִ״̬жϸǷִгɹ */
	if( Check_Cmd_OpStatus( ) != CMD_RET_SUCCESS ) 
	{
		return( ERR_USB_UNKNOWN );  							 /* ͨѶлʧ,ͨӲλCH378 */
	}
#endif


#if  0 
	/* VIDPID */
	xWriteCH378Cmd( CMD40_SET_USB_ID );  						 /* 豸оƬVIDPID */
	xWriteCH378Data( 0x43 );									 			
	xWriteCH378Data( 0x48 );									 			
	xWriteCH378Data( 0x55 );									 			
	xWriteCH378Data( 0x37 );									 			
	xEndCH378Cmd( );
#endif

#if  0
	/* USB ٶ */
	xWriteCH378Cmd( CMD10_SET_USB_SPEED );  					 /* 豸оƬUSBٶ */
	xWriteCH378Data( 0x00 );									 /* ȫģʽ */									 												 			
	xEndCH378Cmd( );
	USBSpeed = USB_DEV_SPEED_FS;								 /* ٶΪȫٱ־ */
#endif

	/* CH378ģʽ */
	xWriteCH378Cmd( CMD11_SET_USB_MODE );  						 /* 豸USBģʽ */
	xWriteCH378Data( 0x01 );									 /* ù̼ģʽ */

	/* ȴģʽ,ڲSDҪ10mSʱ,ڲUSB豸Ҫ35mSʱ */	
	mDelaymS( 50 );											 
	res = xReadCH378Data( );
	xEndCH378Cmd( );
#ifndef	CH378_INT_WIRE
	xWriteCH378Cmd( CMD20_SET_SDO_INT );  						 /* SPISDOŵжϷʽ */
	xWriteCH378Data( 0x16 );
	xWriteCH378Data( 0x01 );  					   				 /* SDOSCSƬѡЧʱж */
	xEndCH378Cmd( );
#endif
	if( res == CMD_RET_SUCCESS ) 
	{
		return( ERR_SUCCESS );
	}
	else 
	{
		return( ERR_USB_UNKNOWN );  							 /* ģʽ */
	}
}

/*******************************************************************************
* Function Name  : CH378_Dev_ReadReqBlock
* Description    : ӵǰ豸˵Ľջȡݿ
* Input          : index---˵
*                  buf-----ݻ	
* Output         : None
* Return         : س
*******************************************************************************/
UINT16 CH378_Dev_ReadReqBlock( UINT8 index, PUINT8 pbuf ) 
{
	UINT16 len, l;

	xWriteCH378Cmd( CMD1x_RD_USB_DATA );					 	 /* ָUSBжϵĶ˵㻺ȡݿ,ͷŻ */		
	xWriteCH378Data( index );									 /* ˵ */
	len = xReadCH378Data( );
	len += ( ( UINT16 )xReadCH378Data( ) << 8 );				 /* ȡ2ֽݳ */
	mDelayuS( 1 ); 												 /* ڸMCU,ڴ˴ʵʱ */		
	l = len;
	if( len )													 /* ѭȡݿ */
	{
		do
		{		
			*pbuf = xReadCH378Data( );	
			pbuf++;
		}while( --l );		
	}
	xEndCH378Cmd( );
	return( len );
}

/*******************************************************************************
* Function Name  : CH378_Dev_WriteBlock
* Description    : ǰ豸˵ķͻдݿ
* Input          : index---˵
*                  buf-----ݻ
*	               len-----дݿ鳤
* Output         : None
* Return         : None
*******************************************************************************/
void CH378_Dev_WriteBlock( UINT8 index, PUINT8 pbuf, UINT16 len ) 
{
	UINT16 l;

	xWriteCH378Cmd( CMD30_WR_USB_DATA );					 	 /*  ָUSB˵ķͻдݿ */		
	xWriteCH378Data( index );
	xWriteCH378Data( ( UINT8 )len );
	xWriteCH378Data( ( UINT8 )( len >> 8 ) );
	mDelayuS( 1 ); 												 /* ڸMCU,ڴ˴ʵʱ */							
	l = len;
	if( len )
	{
		do
		{		
			xWriteCH378Data( *pbuf++ );							 /* ѭдݿ */
		}while( --l );		
	}
	xEndCH378Cmd( );
}

/*******************************************************************************
* Function Name  : CH378_Endp0_UP
* Description    : ˵0ϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH378_Endp0_UP( void )
{
	UINT16 len;
	UINT16 l;
	UINT8  *p;

	len = SetupLength >= 64 ? 64 : SetupLength;  				 /* 㱾δ䳤 */								                        						/* ȴ6464,ܳȼ64 */
	memcpy( Dev_Buf, pSetupDescr, len );  						 /* FlashROMеconstݸƵRAMУԱDMAȡ */
	SetupLength -= len;							  				 /* 㴫䳤 */
	pSetupDescr += len;									 		 /* ָƫ */

	xWriteCH378Cmd( CMD10_WR_USB_DATA0 );						 /*  ָUSB˵ķͻдݿ */		
	xWriteCH378Data( ( UINT8 )len );
	mDelayuS( 1 ); 												 /* ڸMCU,ڴ˴ʵʱ */							
	l = len;
	p = Dev_Buf;
	if( len )
	{
		do
		{		
			xWriteCH378Data( *p++ );							 /* ѭдݿ */
		}while( --l );		
	}
	xEndCH378Cmd( );
}
					
/*******************************************************************************
* Function Name  : main
* Description    : Main routine.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int main( void )
{
	UINT8  status;
	UINT16 len, l;
	UINT8  *pbuf;
	
	mDelaymS( 100 );  											 /* ʱ100 */
	mInitSTDIO( );  											 /* Ϊüͨڼʾ */

#if    ( IC_OP_INTERFACE_MODE == 1 )
	printf(" MCS51_CH378_PARA_HW V1.2 2015.08.28...\n");		 /* Ӳ߲ӷʽ */						 			 
#elif  ( IC_OP_INTERFACE_MODE == 2 )
	printf(" MCS51_CH378_PARA_SW V1.2 2015.08.28...\n"); 		 /* ģⲢӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 3 )
	printf(" MCS51_CH378_SPI_HW V1.2 2015.08.28...\n"); 		 /* ӲSPIӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 4 )
	printf(" MCS51_CH378_SPI_SW V1.2 2015.08.28...\n");			 /* ģSPIʽ */
#elif  ( IC_OP_INTERFACE_MODE == 5 )
	printf(" MCS51_CH378_UART_HW V1.2 2015.08.28...\n");		 /* Ӳ첽ӷʽ */
#else
	printf(" MCS51_CH378_INTERFACE ERROR 2015.08.28...\n");
#endif

	printf( "Test Start\n" );
	mDelaymS( 200 );
	status = mInitCH378Device( );  								 /* ʼCH378豸ģʽ */
	mStopIfError( status );
	/* ·ʼ */

	while( 1 )
	{
		if( Query378Interrupt( ) ) 	   							 /* ⵽ж */	
		{
			/* ȡж״̬ */
			xWriteCH378Cmd( CMD01_GET_STATUS );					 /* Ͷȡж״̬ */
			status = xReadCH378Data( );
			xEndCH378Cmd( );
			switch( status )
			{
				case USB_INT_INDEX3_IN:							 /* 3ӦĶ˵ϴɹж */
//					printf("INDEX3_IN\n");

					/* ͨӦϴ˵شݰ */
					pbuf = Dev_Buf;
					xWriteCH378Cmd( CMD30_WR_USB_DATA );		 /* ָUSB˵ķͻдݿ */		
					xWriteCH378Data( ENDP_INDEX_3 );		   	 /* ˵ */
					xWriteCH378Data( ( UINT8 )len );
					xWriteCH378Data( ( UINT8 )( len >> 8 ) );
					mDelayuS( 1 ); 								 /* ڸMCU,ڴ˴ʵʱ */							
					if( USBSpeed == USB_DEV_SPEED_FS )
					{
						len = 64;
					}
					else
					{
						len = 512;
					}
					l = len;
					if( len )
					{
						do
						{		
							xWriteCH378Data( *pbuf++ );		     /* ѭдݿ */
						}while( --l );		
					}
					xEndCH378Cmd( );
					break;

				case USB_INT_INDEX4_OUT:						 /* 4ӦĶ˵´ɹж */
					printf("INDEX4_OUT \n");
					pbuf = Dev_Buf;
					xWriteCH378Cmd( CMD1x_RD_USB_DATA );		 /* ָUSBжϵĶ˵㻺ȡݿ,ͷŻ */		
					xWriteCH378Data( ENDP_INDEX_4 );		  	 /* ˵ */
					len = xReadCH378Data( );
					len += ( ( UINT16 )xReadCH378Data( ) << 8 ); /* ȡ2ֽݳ */
					mDelayuS( 1 ); 				 			 	 /* ڸMCU,ڴ˴ʵʱ */		
					l = len;
					if( len )									 /* ѭȡݿ */
					{
						do
						{		
							*pbuf = xReadCH378Data( );	
							pbuf++;
						}while( --l );		
					}
					xEndCH378Cmd( );

					/* ͨӦϴ˵شݰ */
					pbuf = Dev_Buf;
					xWriteCH378Cmd( CMD30_WR_USB_DATA );		 /* ָUSB˵ķͻдݿ */		
					xWriteCH378Data( ENDP_INDEX_3 );		   	 /* ˵ */
					xWriteCH378Data( ( UINT8 )len );
					xWriteCH378Data( ( UINT8 )( len >> 8 ) );
					mDelayuS( 1 ); 								 /* ڸMCU,ڴ˴ʵʱ */							
					if( USBSpeed == USB_DEV_SPEED_FS )
					{
						len = 64;
					}
					else
					{
						len = 512;
					}
					l = len;
					if( len )
					{
						do
						{		
							xWriteCH378Data( *pbuf++ );		     /* ѭдݿ */
						}while( --l );		
					}
					xEndCH378Cmd( );

					break;

				case USB_INT_INDEX1_IN:							 /* 1ӦĶ˵ϴɹж */
					printf("INDEX1_IN\n");
					break;

				case USB_INT_INDEX2_OUT:						 /* 2ӦĶ˵´ɹж */
					printf("INDEX2_OUT\n");
					pbuf = Dev_Buf;
					xWriteCH378Cmd( CMD1x_RD_USB_DATA );		 /* ָUSBжϵĶ˵㻺ȡݿ,ͷŻ */		
					xWriteCH378Data( ENDP_INDEX_2 );			 /* ˵ */
					len = xReadCH378Data( );
					len += ( ( UINT16 )xReadCH378Data( ) << 8 ); /* ȡ2ֽݳ */
					mDelayuS( 1 ); 								 /* ڸMCU,ڴ˴ʵʱ */		
					l = len;
					if( len )									 /* ѭȡݿ */
					{
						do
						{		
							*pbuf = xReadCH378Data( );	
							pbuf++;
						}while( --l );		
					}
					xEndCH378Cmd( );

					/* ͨӦϴ˵شݰ */
					pbuf = Dev_Buf;
					xWriteCH378Cmd( CMD30_WR_USB_DATA );		 /* ָUSB˵ķͻдݿ */		
					xWriteCH378Data( ENDP_INDEX_1 );   			 /* ˵ */
					xWriteCH378Data( ( UINT8 )len );
					xWriteCH378Data( ( UINT8 )( len >> 8 ) );
					mDelayuS( 1 ); 								 /* ڸMCU,ڴ˴ʵʱ */							
					l = len;
					if( len )
					{
						do
						{		
							xWriteCH378Data( *pbuf++ );			 /* ѭдݿ */
						}while( --l );		
					}
					xEndCH378Cmd( );
					break;
	
				case USB_INT_EP0_SETUP: 						 /* ƶ˵SETUP׶ */
					printf("Endp0_Setup\n");
					len = CH378_Dev_ReadReqBlock( 0x00, USBRequest.buf );		
#if   1
					for( l = 0; l < len; l++ )
					{
						printf("%x ",(UINT16)USBRequest.buf[ l ]);
					}
					printf("\n");
#endif					
					if( len == 0x08 )
					{
					    SetupLength = USBRequest.buf[ 6 ] + USBRequest.buf[ 7 ] * 256;	
						Bit_Error_Flag = 0x00;
						if( USBRequest.req.bmRequestType & 0x40 )		 		/*  */
						{    
							/* ڳ,δ */
							Bit_Error_Flag = 1;				 					/* ô־ */	     					 
						}
						else if( USBRequest.req.bmRequestType & 0x20 )	 		/*  */
						{
							/* ,δ */	 
							Bit_Error_Flag = 1;				 					/* ô־ */    					 					
						}
						else if( !( USBRequest.req.bmRequestType & 0x60 ) )	   	/* ׼USB */
						{          				
							SetupRequest = USBRequest.req.bRequest;		 	   	/* ݴ׼ */

							/* ׼USB,ӦĴ */
							switch( USBRequest.req.bRequest )
							{  
								case DEF_USB_GET_DESCR: 				 		/* ׼USB: ȡ */
									if( USBRequest.buf[ 3 ] == 0x01 )			/* ȡ豸 */
									{
										pSetupDescr = (UINT8 *)MyDevDescr;		 
										SetupLength = 0x12;						/* ϴΪʵʳ */	
									}
									else if( USBRequest.buf[ 3 ] == 0x02 )		/* ȡ */
									{
										/* ȡʵٶ */		
										xWriteCH378Cmd( CMD01_GET_USB_SPEED );  /* 豸оƬUSBٶ */
									 	USBSpeed = xReadCH378Data( );											 			
										xEndCH378Cmd( );
										
										/* ʵٶȷ */	
										if( USBSpeed == USB_DEV_SPEED_FS )	  	/* ȫģʽ */
										{
											pSetupDescr = (UINT8 *)My_FS_CfgDescr;
											if( SetupLength >= My_FS_CfgDescr[ 2 ] )/* ϴΪʵʳ */
											{
												SetupLength = My_FS_CfgDescr[ 2 ];
											}											
										}
										else
										{
											pSetupDescr = (UINT8 *)My_HS_CfgDescr;
											if( SetupLength >= My_HS_CfgDescr[ 2 ] )/* ϴΪʵʳ */
											{
												SetupLength = My_HS_CfgDescr[ 2 ];
											}
										}
									}
									else if( USBRequest.buf[ 3 ] == 0x03 )	  	/* ȡַ */
									{
										if( USBRequest.buf[ 2 ] == 0x00 ) 
										{
											pSetupDescr = (UINT8 *)MyLangDescr; /* ȡ */ 
											if( SetupLength >= 0x04 )       	/* ϴΪʵʳ */
											{
												SetupLength = 0x04;
											}
										}
										else if( USBRequest.buf[ 2 ] == 0x01 ) 
										{
											pSetupDescr = (UINT8 *)MyManuInfo;  /* ȡַ */ 
											if( SetupLength >= MyManuInfo[ 0 ] )/* ϴΪʵʳ */
											{
												SetupLength = MyManuInfo[ 0 ];
											}	
										}
										else if( USBRequest.buf[ 2 ] == 0x02 ) 
										{
											pSetupDescr = (UINT8 *)MyProdInfo;		
											if( SetupLength >= MyProdInfo[ 0 ] )/* ϴΪʵʳ */
											{
												SetupLength = MyProdInfo[ 0 ];
											}										
										}								
										else if( USBRequest.buf[ 2 ] == 0x03 ) 
										{	
											Bit_Error_Flag = 1;																		
										}																
									}				          							
									else if( USBRequest.buf[ 3 ] == 0x06 )	  	/* ȡ豸޶ */
									{
										pSetupDescr = (UINT8 *)My_QueDescr;
										if( SetupLength >= My_QueDescr[ 0 ] )	/* ϴΪʵʳ */
										{
											SetupLength = My_QueDescr[ 0 ];
										}
									}
									else if( USBRequest.buf[ 3 ] == 0x07 )	  	/* ٶ */
									{
										if( USBSpeed == USB_DEV_SPEED_FS )	  	/* ȫģʽ */
										{
											pSetupDescr = (UINT8 *)My_FS_OscDescr;
											if( SetupLength >= My_FS_OscDescr[ 2 ] )/* ϴΪʵʳ */
											{
												SetupLength = My_FS_OscDescr[ 2 ];
											}											
										}
										else
										{
											pSetupDescr = (UINT8 *)My_HS_OscDescr;
											if( SetupLength >= My_HS_OscDescr[ 2 ] )/* ϴΪʵʳ */
											{
												SetupLength = My_HS_OscDescr[ 2 ];
											}
										}										
									}
									else
									{
										Bit_Error_Flag = 1;				 		/* ô־ */	
									}
									break;
									
								case DEF_USB_SET_ADDRESS:				 		/* ׼USB: õַ */
									USBAddress = USBRequest.buf[ 2 ];	 		/* ݴUSBĵַ */
	  								
									/* õַоƬڲд */
									mDelaymS( 3 );	
									break;
									
								case DEF_USB_GET_CONFIG:				 		/* ׼USB:  */
									USBRequest.buf[ 0 ] = USBConfig;
									pSetupDescr = USBRequest.buf; 
									SetupLength = 1;
									break;																	
									
								case DEF_USB_SET_CONFIG:                 		/* ׼USB:  */
									USBFlag |= DEF_BIT_USB_SET_CFG;				/* ñ־ */
									USBConfig = USBRequest.buf[ 2 ];
									break;
									
								case DEF_USB_CLR_FEATURE:						/* Clear Feature */
									if( ( USBRequest.req.bmRequestType & 0x1F ) == 0x00 ) /* 豸 */ 
									{ 										
										if( ( USBRequest.req.wValue ) == 0x01 )
										{
											if( USBSpeed == USB_DEV_SPEED_HS )	/* ģʽ */
											{
												if( My_HS_CfgDescr[ 7 ] & 0x20 ) 
												{
													USBFlag &= ~DEF_BIT_USB_WAKE; /* ûѽֹ־ */
												}
												else 
												{
													Bit_Error_Flag = 1;			/* ô־ */
												}
											}
											else
											{
												if( My_FS_CfgDescr[ 7 ] & 0x20 ) 
												{	
													USBFlag &= ~DEF_BIT_USB_WAKE;/* ûѽֹ־ */
												}
												else 
												{
													Bit_Error_Flag = 1;			/* ô־ */
												}
											}
										}
										else 
										{
											Bit_Error_Flag = 1;					/* ô־ */
										}	
									}					
									else if( ( USBRequest.req.bmRequestType & 0x1F ) == 0x02 ) /* ˵ */
									{  	
										switch( USBRequest.req.wIndx ) 
										{
											case 0x82:
												/* ˵STALL */
												xWriteCH378Cmd( CMD20_SET_INDEXx_IN );					
												xWriteCH378Data( ENDP_INDEX_3 );
												xWriteCH378Data( 0x20 );		   				
												xEndCH378Cmd( );
												USBEndStatus[ 2 ] = 0x00;		/* ö˵״̬ */

												/* λͬ־ */
												xWriteCH378Cmd( CMD20_SET_INDEXx_IN );					
												xWriteCH378Data( ENDP_INDEX_3 );
												xWriteCH378Data( 0x80 );		   				
												xEndCH378Cmd( );												
												break;
											
											case 0x02:
												/* ˵STALL */
												xWriteCH378Cmd( CMD20_SET_INDEXx_OUT );					
												xWriteCH378Data( ENDP_INDEX_4 );
												xWriteCH378Data( 0x20 );		   				
												xEndCH378Cmd( );
												USBEndStatus[ 3 ] = 0x00;		/* ö˵״̬ */

												/* λͬ־ */
												xWriteCH378Cmd( CMD20_SET_INDEXx_OUT );					
												xWriteCH378Data( ENDP_INDEX_4 );
												xWriteCH378Data( 0x80 );		   				
												xEndCH378Cmd( );
												break;
											
											case 0x81:
												/* ˵STALL */
												xWriteCH378Cmd( CMD20_SET_INDEXx_IN );					
												xWriteCH378Data( ENDP_INDEX_1 );
												xWriteCH378Data( 0x20 );		   				
												xEndCH378Cmd( );
												USBEndStatus[ 0 ] = 0x00;		/* ö˵״̬ */

												/* λͬ־ */
												xWriteCH378Cmd( CMD20_SET_INDEXx_IN );					
												xWriteCH378Data( ENDP_INDEX_1 );
												xWriteCH378Data( 0x80 );		   				
												xEndCH378Cmd( );
												break;
											
											case 0x01:
												/* ˵STALL */
												xWriteCH378Cmd( CMD20_SET_INDEXx_OUT );					
												xWriteCH378Data( ENDP_INDEX_2 );
												xWriteCH378Data( 0x20 );		   				
												xEndCH378Cmd( );
												USBEndStatus[ 1 ] = 0x00;		/* ö˵״̬ */

												/* λͬ־ */
												xWriteCH378Cmd( CMD20_SET_INDEXx_OUT );					
												xWriteCH378Data( ENDP_INDEX_2 );
												xWriteCH378Data( 0x80 );		   				
												xEndCH378Cmd( );
												break;
											
											default:
												Bit_Error_Flag = 1;				/* ô־ */
												break;
										}
									}
									else
									{
										Bit_Error_Flag = 1;						/* ô־ */
									}
									break;

								case DEF_USB_SET_FEATURE:						/* Set Feature */
									if( ( USBRequest.req.bmRequestType & 0x1F ) == 0x00 )/* 豸 */
									{
										if( ( USBRequest.req.wValue ) == 0x01 )
										{
											if( USBSpeed == USB_DEV_SPEED_HS )	/* ģʽ */
											{
												if( My_HS_CfgDescr[ 7 ] & 0x20 ) 
												{
													USBFlag |= DEF_BIT_USB_WAKE;/* ûʹܱ־ */
												}
												else 
												{
													Bit_Error_Flag = 1;			/* ô־ */
												}
											}
											else
											{
												if( My_HS_CfgDescr[ 7 ] & 0x20 ) 
												{
													USBFlag |= DEF_BIT_USB_WAKE;/* ûʹܱ־ */
												}
												else 
												{	
													Bit_Error_Flag = 1;			/* ô־ */
												}
											}
										}
										else 
										{
											Bit_Error_Flag = 1;					/* ô־ */
										}
									}
									else if( ( USBRequest.req.bmRequestType & 0x1F ) == 0x02 )/* ö˵ */
									{
										if( ( USBRequest.req.wValue ) == 0x00 )
										{
											switch( USBRequest.req.wIndx ) /* ˵ */
											{
												case 0x82:
													/* ö˵ IN STALL */
													xWriteCH378Cmd( CMD20_SET_INDEXx_IN );					
													xWriteCH378Data( ENDP_INDEX_3 );
													xWriteCH378Data( 0x40 );		   				
													xEndCH378Cmd( );
													USBEndStatus[ 2 ] = 0x01;	/* ö˵״̬ */																	
													break;
				
												case 0x02:
													/* ö˵ OUT STALL */
													xWriteCH378Cmd( CMD20_SET_INDEXx_OUT );					
													xWriteCH378Data( ENDP_INDEX_4 );
													xWriteCH378Data( 0x40 );		   				
													xEndCH378Cmd( );
													USBEndStatus[ 3 ] = 0x01;	/* ö˵״̬ */
													break;
				
												case 0x81:
													/* ö˵ IN STALL */
													xWriteCH378Cmd( CMD20_SET_INDEXx_IN );					
													xWriteCH378Data( ENDP_INDEX_1 );
													xWriteCH378Data( 0x40 );		   				
													xEndCH378Cmd( );
													USBEndStatus[ 0 ] = 0x01;	/* ö˵״̬ */
													break;
				
												case 0x01:
													/* ö˵ OUT STALL */
													xWriteCH378Cmd( CMD20_SET_INDEXx_OUT );					
													xWriteCH378Data( ENDP_INDEX_2 );
													xWriteCH378Data( 0x40 );		   				
													xEndCH378Cmd( );
													USBEndStatus[ 1 ] = 0x01;	/* ö˵״̬ */
													break;
				
												default:
													Bit_Error_Flag = 1;			/* ô־ */
													break;
											}
										}
										else 
										{
											Bit_Error_Flag = 1;					/* ô־ */
										}
									}
									else 
									{
										Bit_Error_Flag = 1;						/* ô־ */
									}	
									break;

								case DEF_USB_SET_INTERF:						/* Set Interface */
									USBInterCfg = (UINT8)USBRequest.req.wIndx;	/* ӿ */
									break;
								
								case DEF_USB_GET_INTERF:						/* CMD: GET_INTERF */										
									USBRequest.buf[ 0 ] = USBInterCfg;
									pSetupDescr = USBRequest.buf; 
									SetupLength = 1;
									break;							
																	
								case DEF_USB_GET_STATUS:						/* Get Status */
									if( ( USBRequest.req.bmRequestType & 0x1F ) == 0x00 )/* ȡ豸״̬ */
									{
										if( ( USBRequest.req.wValue ) == 0x00 && 
										    ( USBRequest.req.wIndx ) == 0x00 )
										{
											USBRequest.buf[ 0 ] = ( USBFlag & DEF_BIT_USB_WAKE ) ? 0x02 : 0x00;
											USBRequest.buf[ 1 ] = 0x00;
											pSetupDescr = USBRequest.buf;
											SetupLength = 2;
										}
										else 
										{
											Bit_Error_Flag = 1;					/* ô־ */	
										}
									}
									else if( ( USBRequest.req.bmRequestType & 0x1F ) == 0x02 )/* ȡ˵״̬ */
									{
										if( ( USBRequest.req.wValue ) == 0x00 )
										{
											switch( USBRequest.req.wIndx )	/* ˵ */
											{
												case 0x82:
													USBRequest.buf[ 0 ] = USBEndStatus[ 2 ] ? 0x01 : 0x00;
													break;
				
												case 0x02:
													USBRequest.buf[ 0 ] = USBEndStatus[ 3 ] ? 0x01 : 0x00;
													break;
				
												case 0x81:
													USBRequest.buf[ 0 ] = USBEndStatus[ 0 ] ? 0x01 : 0x00;
													break;
				
												case 0x01:
													USBRequest.buf[ 0 ] = USBEndStatus[ 1 ] ? 0x01 : 0x00;
													break;
				
												default:
													Bit_Error_Flag = 1;			/* ô־ */
													break;
											}
											USBRequest.buf[ 1 ] = 0x00;
											pSetupDescr = USBRequest.buf; 
											SetupLength = 2;							
										}
										else 
										{
											Bit_Error_Flag = 1;					/* ô־ */
										}
									}
									else 
									{
										Bit_Error_Flag = 1;						/* ô־ */
									}
									break;
						
								default :								 		/* δ֪ */
									Bit_Error_Flag = 1;				 			/* ô־ */
									break;
							}
						}
					}
					else 												 		/* ƴ,ȿ϶8ֱ, */
					{  
						Bit_Error_Flag = 1;							 			/* ô־ */
					}
	
					/* õַ,ֱ˳ */
					if( USBRequest.req.bRequest ==DEF_USB_SET_ADDRESS )
					{
						break;
					}

					if( !Bit_Error_Flag ) 								 		/* ޴,ϴ,ϴ */
					{
						CH378_Endp0_UP( );								 
					}
					else 												 		/* д,ö˵ΪSTALL */
					{
						/* ö˵0 STALL */
						xWriteCH378Cmd( CMD20_SET_INDEXx_IN );					
						xWriteCH378Data( ENDP_INDEX_0 );
						xWriteCH378Data( 0x40 );		   				
						xEndCH378Cmd( );
					}
					break;
				
				case USB_INT_EP0_IN:									 		/* ƶ˵ǰһϴɹ */
					printf("Endp0_IN\n");
					if( SetupRequest == DEF_USB_GET_DESCR )			 			/* ǰΪ:ϴ,ϴδ */
					{								
						CH378_Endp0_UP( );															
					}
					break;
				
				case USB_INT_EP0_OUT:									 		/* ƶ˵´ɹ,ʵδд */
					printf("Endp0_OUT\n");
					CH378_Dev_WriteBlock( 0x00, Dev_Buf, 64 );	 				/* ȡ */
					break;

				case USB_INT_BUS_SUSP:											/* USB߹ж */
					printf("BUS_SUSP\n");	
					break;

				case USB_INT_BUS_RESET:											/* USB߸λж */
					printf("BUS_RESET\n");	
					break;

				default:
				    break;
			}								 
		}
	}	
}

