/********************************** (C) COPYRIGHT *******************************
* File Name          : SPI_HW.C
* Author             : MJX
* Version            : V1.20
* Date               : 2015/08/28
* Description        : CH378оƬ CH378оƬ Ӳ׼SPIӵӲ V1.0
*                      ṩI/Oӿӳ
*******************************************************************************/



/*******************************************************************************/
/* ͷļ */
#include "../myfile/HAL.h"										 /* CH378Ӳͷļ */	

/*******************************************************************************/
/* Ӳغ궨 */
/* еӲӷʽ(ʵӦõ·Բ޸弰ӳ) */
/* Ƭ               CH378оƬ
    SPI1_NSS-----PB0            	SCS
    SPI1_SCK-----PA5            	SCK      
    SPI1_MISO----PA6            	SDO
    SPI1_MOSI----PA7            	SDI
    INT#---------PA1                INT#
*/
#define CH378_SPI_SCS_LOW( )       ( GPIOB->BRR  = GPIO_Pin_0 )   /* SPIƬѡ͵ƽ */
#define CH378_SPI_SCS_HIGH( )      ( GPIOB->BSRR = GPIO_Pin_0 )   /* SPIƬѡߵƽ */
#define	CH378_SPI_SDO_PIN( )	   GPIO_ReadInputDataBit( GPIOA, GPIO_Pin_6 ) /* ȡCH378SPIŵƽ */

#define CH378_INT_WIRE     		   1	 
#define	CH378_INT_PIN_WIRE( )	   GPIOA->IDR & GPIO_Pin_1 		  /* ٶCH378INT#,δôҲͨѯжSDO״̬ʵ */
								   
/*******************************************************************************
* Function Name  : CH378_Port_Init
* Description    : CH378˿ڳʼ
*                  ʹSPIдʱ,Խгʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH378_Port_Init( void )  
{
	SPI_InitTypeDef  SPI_InitStructure;
 	GPIO_InitTypeDef GPIO_InitStructure;

	/* ʼSPIӿ */   
	/* Enable SPI1 and GPIOA clocks */
	RCC_APB2PeriphClockCmd( RCC_APB2Periph_SPI1 | RCC_APB2Periph_GPIOA | RCC_APB2Periph_GPIOB, ENABLE );/* ʵ֮ǰѾʹܹ */
  
	/* Configure SPI1 pins: NSS, SCK, MISO and MOSI */
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7 ;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode =  GPIO_Mode_AF_PP;	  		 /* ù */
	GPIO_Init( GPIOA, &GPIO_InitStructure );

  	/* Configure PA.4 as Output push-pull, used as Flash Chip select */
  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;  			 /*  */
  	GPIO_Init( GPIOB, &GPIO_InitStructure );

  	/* Deselect the SD: Chip Select high */
  	CH378_SPI_SCS_HIGH( );
 
  	/* SPI1 configuration */ 
  	SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex; /* SPIóߵĵȫ˫ͨ */
  	SPI_InitStructure.SPI_Mode = SPI_Mode_Master;	 				   /* SPI */
  	SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;				   /* SPI8λݸʽ */
  	SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;	  					   /* ʱӵʱ */  				//	ĳɸ?????????????????
  	SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge;					   /* ʱӵڶʱ */
  	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;		 				   /* ڲNSSźSSI */
    SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_4; /* ԤƵΪ4 */
  	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;		   		   /* ʱλǰ */
  	SPI_InitStructure.SPI_CRCPolynomial = 7;			  			  	    
  	SPI_Init( SPI1, &SPI_InitStructure );
  
  	/* Enable SPI1  */
  	SPI_Cmd( SPI1, ENABLE );   							
	
	/* ʼж */
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;  				 /*  */
    GPIO_Init( GPIOA, &GPIO_InitStructure );				
}

/*******************************************************************************
* Function Name  : Spi376Exchange
* Description    : ӲSPI8λ
* Input          : d---Ҫ뵽CH378
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 Spi376Exchange( UINT8 d )  
{  
	/* Loop while DR register in not emplty */
//	while(SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_TXE) == RESET);	
	while( ( SPI1->SR & SPI_I2S_FLAG_TXE ) == RESET );

	/* Send byte through the SPI1 peripheral */
//	SPI_I2S_SendData(SPI1, byte);
	SPI1->DR = d;

	/* Wait to receive a byte */
//	while(SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_RXNE) == RESET);
	while( ( SPI1->SR & SPI_I2S_FLAG_RXNE ) == RESET );

	/* Return the byte read from the SPI bus */
//	return  SPI_I2S_ReceiveData(SPI1);
	return( SPI1->DR );	
} 

/*******************************************************************************
* Function Name  : xWriteCH378Cmd
* Description    : CH378д
* Input          : mCmd---ҪдCH378
* Output         : None
* Return         : None
*******************************************************************************/
void xWriteCH378Cmd( UINT8 mCmd )  
{
	CH378_SPI_SCS_HIGH( );  									 /* ֹ֮ǰδͨxEndCH378CmdֹSPIƬѡ */
	CH378_SPI_SCS_HIGH( ); 
			
	/* ˫I/OģSPIӿ,ôȷѾSPI_SCS,SPI_SCK,SPI_SDIΪ,SPI_SDOΪ뷽 */
	CH378_SPI_SCS_LOW( );  										 /* SPIƬѡЧ */

	/*  */
	Spi376Exchange( mCmd );  									 /*  */
	mDelayuS( 2 );  											 /* ʱ1.5uSȷдڴ1.5uS */
}

/*******************************************************************************
* Function Name  : xWriteCH378Data
* Description    : CH378д
* Input          : mData---ҪдCH378
* Output         : None
* Return         : None
*******************************************************************************/
void xWriteCH378Data( UINT8 mData ) 
{
	Spi376Exchange( mData );  									 /*  */
}

/*******************************************************************************
* Function Name  : xReadCH378Data
* Description    : CH378
* Input          : None
* Output         : None
* Return         : ضȡ
*******************************************************************************/
UINT8 xReadCH378Data( void ) 
{
	return( Spi376Exchange( 0xFF ) );  	
}

#define	xEndCH378Cmd( )	{ CH378_SPI_SCS_HIGH( ); }  			 /* SPIƬѡЧ,CH378,SPIӿڷʽ */

/*******************************************************************************
* Function Name  : Query378Interrupt
* Description    : ѯCH378ж(INT#͵ƽ)
* Input          : None
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 Query378Interrupt( void )
{
	/* CH378жֱӲѯж */
	/* δCH378жѯжSDO״̬ */
#ifdef	CH378_INT_WIRE
	return( CH378_INT_PIN_WIRE( ) ? FALSE : TRUE );  
#else
	return( CH378_SPI_SDO_PIN( ) ? FALSE : TRUE );  
#endif
}

/*******************************************************************************
* Function Name  : mInitCH378Host
* Description    : ʼCH378
* Input          : None
* Output         : None
* Return         : ز״̬
*******************************************************************************/
UINT8 mInitCH378Host( void ) 
{
	UINT8  res;

	/* CH378Ƿ */	
	CH378_Port_Init( );  										 /* ӿӲʼ */
	xWriteCH378Cmd( CMD11_CHECK_EXIST );  						 /* ԵƬCH378֮ͨѶӿ */
	xWriteCH378Data( 0x65 );
	res = xReadCH378Data( );
	xEndCH378Cmd( );
	if( res != 0x9A ) 
	{
		/* ͨѶӿڲ,ԭ:ӿ쳣,豸Ӱ(ƬѡΨһ),ڲ,һֱڸλ,񲻹 */
		return( ERR_USB_UNKNOWN );  
	}	

	/* CH378ģʽ */
	xWriteCH378Cmd( CMD11_SET_USB_MODE );  						 /* 豸USBģʽ */
//	xWriteCH378Data( 0x04 );
	xWriteCH378Data( 0x07 );

	/* ȴģʽ,ڲSDҪ10mSʱ,ڲUSB豸Ҫ35mSʱ */	
	mDelaymS( 50 );											 
	res = xReadCH378Data( );
	xEndCH378Cmd( );
#ifndef	CH378_INT_WIRE
	xWriteCH378Cmd( CMD20_SET_SDO_INT );  						 /* SPISDOŵжϷʽ */
	xWriteCH378Data( 0x16 );
	xWriteCH378Data( 0x01 );  									 /* SDOSCSƬѡЧʱж */
	xEndCH378Cmd( );
#endif
	if( res == CMD_RET_SUCCESS ) 
	{
		return( ERR_SUCCESS );
	}
	else 
	{
		return( ERR_USB_UNKNOWN );  							 /* ģʽ */
	}
}


