/********************************** (C) COPYRIGHT *******************************
* File Name          : Main.C
* Author             : MJX
* Version            : V1.20
* Date               : 2015/08/28
* Description        : CH378 ļϵͳӳ(EXAM13)
*                      USB Host File Interface for CH378
*					   TC2.0@PC, KC7.0@MCS51
*******************************************************************************/



/******************************************************************************
˵: 
    MCS-51ƬCԵUļдʾ
    ʾгָĿ¼µļ,Լ/öļ.
*******************************************************************************/



/*******************************************************************************/
/* ͷļ */
#include <reg52.h>
#include <stdio.h>
#include <string.h>
#include "CH378INC.H"											 /* CH378ͷļ */	
#include "HAL.H"												 /* Ӳͷļ */
#include "HAL_BASE.C"											 /* Ӳӳļ */
#include "DEBUG.H"												 /* ӳͷļ */
#include "DEBUG.C"												 /* ӳļ */

/*******************************************************************************/
/* ѡͨѶӿ */
#define	IC_OP_INTERFACE_MODE	 2							 	 /* оƬӿģʽ(1:Ӳ;  2:ģⲢ; 
                                                                    	                 3:ӲSPI; 4:ģSPI; 5:첽) */                                                                    
#if    ( IC_OP_INTERFACE_MODE == 1 )
#include "PARA_HW.C"											 /* Ӳ߲ӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 2 )
#include "PARA_SW.C"										 	 /* ģⲢӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 3 )
#include "SPI_HW.C"										 	 	 /* ӲSPIӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 4 )
#include "SPI_SW.C"												 /* ģSPIʽ */
#elif  ( IC_OP_INTERFACE_MODE == 5 )
#include "UART_HW.C"										 	 /* Ӳ첽ӷʽ */
#else
#error: You Must Include Right Interface Operate File!!!
#endif

/*******************************************************************************/
/* ѡҪĺ */	 	
//#define EN_DISK_QUERY		       1							 /* ѯʣռѯӳ */
//#define EN_DIR_CREATE			   1							 /* ½༶Ŀ¼ӳ */	
//#define EN_SECTOR_ACCESS   	   1							 /* Ϊλдļӳ */		
//#define EN_LONG_NAME	   		   1							 /* ֳ֧ļӳ */		
//#define EN_OTHER_FUNCTION   	   1							 /* ǳӳ */		

#include "FILE_SYS.H"											 /* ļϵͳͷļ */
#include "FILE_SYS.C"											 /* ļϵͳӳļ */

/*******************************************************************************/
/*  */
UINT16 SecterSize;												 /* ǰUÿС */  
UINT8 buf[ 64 ];

typedef struct _FILE_NAME 
{
	UINT32 DirStartClust;										 /* ļĿ¼ʼغ */
//	UINT32 Size;											 	 /* ļ */
	UINT8  Name[8+1+3+1];										 /* ļ,8+3ֽ,ָ,,ΪδϼĿ¼· */
	UINT8  Attr;												 /* ļ */
} FILE_NAME;

#define	MAX_FILE_COUNT			   300
FILE_NAME xdata	FileNameBuffer[ MAX_FILE_COUNT ];				 /* ļṹ */
UINT16 FileCount;
UINT32 CurrentDirStartClust;									 /* 浱ǰĿ¼ʼغ,ڼӿļöٺʹٶ */
UINT8  xdata buf[ 64 ];											 /* ݻ */	

/*******************************************************************************
* Function Name  : ListFile
* Description    : оָŵĿ¼µļ
* Input          : index---Ŀ¼ڽṹе
* Output         : None
* Return         : ز״̬
*******************************************************************************/
UINT8 ListFile( UINT16 index )
{
	UINT8  s;
	PUINT8 pNameBuf;
	UINT32 CurrentDirStartClust;  						 		 /* 浱ǰĿ¼ʼغ,ڼӿļöٺʹٶ */
	P_FAT_DIR_INFO	pDir;

	printf( "List Directory.........................: %s\n", FileNameBuffer[ index ].Name );/* ʾǰҪоٵĿ¼ */
	CH378WriteVar32( VAR32_START_CLUSTER, FileNameBuffer[ index ].DirStartClust );  /* ǰĿ¼ϼĿ¼ʼغΪǰغ,൱ڴϼĿ¼ */
	s = CH378FileOpen( FileNameBuffer[ index ].Name );  		 /* Ŀ¼,Ϊ˻ȡĿ¼ʼغٶ */
	if( s == ERR_SUCCESS ) 
	{
		return( ERR_FOUND_NAME );  								 /* ӦǴĿ¼,ǷؽǴļ */
	}
	else if( s != ERR_OPEN_DIR ) 
	{
		return( s );
	}

	CurrentDirStartClust = CH378ReadVar32( VAR32_START_CLUSTER );/* ȡǰĿ¼ʼغ */
	if( index == 0 )											 /* Ŀ¼ */	
	{
		if( CH378ReadVar8( VAR8_DISK_FAT ) != 0x03 )
	 	{
			CurrentDirStartClust = 0;  							 /* FAT12/FAT16Ŀ¼ */
		}	
	}
	CH378FileClose( FALSE );  									 /* ڸĿ¼һҪر */
	
	/* ԵǰĿ¼öٲ */
	CH378WriteVar32( VAR32_START_CLUSTER, CurrentDirStartClust );/* ǰĿ¼ʼغ,൱ڴ򿪵ǰĿ¼ */
	CH378SetFileName( "*" );  	
	xWriteCH378Cmd( CMD0H_FILE_OPEN );  						 /* öļĿ¼ */
	xEndCH378Cmd( );
	while( 1 ) 
	{
		s = Wait378Interrupt( );
		if( s == USB_INT_DISK_READ ) 							 /* ݶ */
		{  			
			/* ļöٹ,ִܲжϵĲ,,Ҫȡļ,ôԽöٳļ
			   沢öٽȡ䳤ļ */
			CH378ReadReqBlock( buf );  							 /* ȡöٵļFAT_DIR_INFOṹ,سsizeof( FAT_DIR_INFO ) */
			
			/* öһļ */
			CH378WriteVar32( VAR32_START_CLUSTER, CurrentDirStartClust );/* ǰĿ¼ʼغ,൱ڴ򿪵ǰĿ¼ */
			xWriteCH378Cmd( CMD0H_FILE_ENUM_GO );  				 /* öļĿ¼,ȷһٷжݿCH378뵥Ƭֱͬʱ,ٶ */
			xEndCH378Cmd( );
			pDir = (P_FAT_DIR_INFO)buf;  						 /* ǰļĿ¼Ϣ */
			if( pDir -> DIR_Name[ 0 ] != '.' ) 
			{  
				/* ǱϼĿ¼,붪 */
				if( pDir -> DIR_Name[ 0 ] == 0x05 ) 
				{
					pDir -> DIR_Name[ 0 ] = 0xE5;  				 /* ַ滻 */
				}
				if( pDir -> DIR_Name[ 8 ] == 'H' && pDir -> DIR_Name[ 9 ] == ' '  /* Ƚļչļ͵ķ */
					|| pDir -> DIR_Name[ 8 ] == 'E' && pDir -> DIR_Name[ 9 ] == 'X' && pDir -> DIR_Name[ 10 ] == 'E' ) 
				{
					printf( "This is a .H or .EXE file\n" );
				}
				if( FileCount < MAX_FILE_COUNT ) 
				{  
					/* ļṹ㹻 */
					pNameBuf = & FileNameBuffer[ FileCount ].Name;/* ļṹеļ */
					for( s = 0; s < 11; s ++ ) 					 /* ļ,Ϊ11ַ */	
					{  						
						if( pDir -> DIR_Name[ s ] != 0x20 ) 	 /* Чַ */
						{  							
							if( s == 8 ) 
							{  
								/* չ */
								*pNameBuf = '.';  				 /* ָ */
								pNameBuf ++;
							}
							*pNameBuf = pDir -> DIR_Name[ s ];   /* ļһַ */
							pNameBuf ++;
						}
					}
					*pNameBuf = 0;  							 /* ǰļ·Ľ */
					FileNameBuffer[ FileCount ].DirStartClust = CurrentDirStartClust;  /* ¼ǰĿ¼ʼغ,ڼӿļٶ */
					FileNameBuffer[ FileCount ].Attr = pDir -> DIR_Attr;  /* ¼ļ */
					if( pDir -> DIR_Attr & ATTR_DIRECTORY ) 
					{
						printf( "Dir %4d#: %s\n", FileCount, FileNameBuffer[ FileCount ].Name );  /* жĿ¼ */
					}
					else 
					{
						printf( "File%4d#: %s\n", FileCount, FileNameBuffer[ FileCount ].Name );  /* жļ */
					}
					FileCount ++;  								 /* Ŀ¼ */
				}
				else 
				{  
					/* ļṹ̫С,ṹ */
					printf( "FileName Structure Full\n" );
					s = Wait378Interrupt( );
					CH378FileClose( FALSE );  						
					break;  									 /* ǿֹö */
				}
			}
		}
		else 
		{
			if( s == ERR_MISS_FILE ) 
			{
				s = ERR_SUCCESS;  							 	 /* ûҵƥļ */
			}
			break;
		}
	}
	return( s );
}


/*******************************************************************************
* Function Name  : ListAll
* Description    : Թȵ㷨öUеļĿ¼
* Input          : None
* Output         : None
* Return         : ز״̬
*******************************************************************************/
UINT8 ListAll( void ) 
{
	UINT8  s;
	UINT16 OldFileCount;
	UINT16 RealReadCount;

	FileNameBuffer[ 0 ].Name[0] = '/';  						 /* Ŀ¼,·,Ŀ¼Ǿ·֮ⶼ· */
	FileNameBuffer[ 0 ].Name[1] = 0;
	FileNameBuffer[ 0 ].DirStartClust = 0;  					 /* Ŀ¼ʼغ */
	FileNameBuffer[ 0 ].Attr = ATTR_DIRECTORY;  				 /* Ŀ¼ҲĿ¼,Ϊһ¼ */
	for( OldFileCount = 0, FileCount = 1; OldFileCount < FileCount; OldFileCount++ ) 
	{  
		/* öٵļṹδз,FileCountڱ仯֮ */
		if( FileNameBuffer[ OldFileCount ].Attr & ATTR_DIRECTORY ) 
		{  
			/* Ŀ¼ */
			s = ListFile( OldFileCount );  						 /* öĿ¼,¼浽ṹ,FileCountܻı */
			if( s != ERR_SUCCESS ) 
			{
				return( s );
			}
		}
	}

	/* UеļĿ¼ȫö,濪ʼݽṹ¼δļ */
	printf( "Total file&dir = %d, Open every file:\n", FileCount );
	for( OldFileCount = 0; OldFileCount < FileCount; OldFileCount ++ ) 
	{
		if( ( FileNameBuffer[ OldFileCount ].Attr & ATTR_DIRECTORY ) == 0 ) 
		{  
			/* ļ,Ŀ¼ */
			printf( "Open file: %s\n", FileNameBuffer[ OldFileCount ].Name );
			CH378WriteVar32( VAR32_START_CLUSTER, FileNameBuffer[ OldFileCount ].DirStartClust ); /* ǰļϼĿ¼ʼغΪǰغ,൱ڴϼĿ¼ */
			s = CH378FileOpen( FileNameBuffer[ OldFileCount ].Name );/* ļ */
			if( s == ERR_SUCCESS ) 
			{  
				/* ɹļ */
				s = CH378ByteRead( buf, sizeof(buf), &RealReadCount );/* ֽΪλӵǰλöȡݿ */
				if( RealReadCount != sizeof(buf) ) 
				{
					printf( "File size = %d\n", RealReadCount ); /* ļȲsizeof(buf) */
				}
				CH378FileClose( FALSE );  						 /* дر */
			}
		}
	}
	return( s );
}

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void main( void ) 
{
	UINT8  status;
	UINT8  i;	

	mDelaymS( 100 );  											 /* ʱ100 */
	mInitSTDIO( );  											 /* Ϊüͨڼʾ */

#if    ( IC_OP_INTERFACE_MODE == 1 )
	printf(" MCS51_CH378_PARA_HW V1.2 2015.08.28...\n");		 /* Ӳ߲ӷʽ */						 			 
#elif  ( IC_OP_INTERFACE_MODE == 2 )
	printf(" MCS51_CH378_PARA_SW V1.2 2015.08.28...\n"); 		 /* ģⲢӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 3 )
	printf(" MCS51_CH378_SPI_HW V1.2 2015.08.28...\n"); 		 /* ӲSPIӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 4 )
	printf(" MCS51_CH378_SPI_SW V1.2 2015.08.28...\n");			 /* ģSPIʽ */
#elif  ( IC_OP_INTERFACE_MODE == 5 )
	printf(" MCS51_CH378_UART_HW V1.2 2015.08.28...\n");		 /* Ӳ첽ӷʽ */
#else
	printf(" MCS51_CH378_INTERFACE ERROR 2015.08.28...\n");
#endif

	status = mInitCH378Host( );  								 /* ʼCH378 */								 	
	mStopIfError( status );
	/* ·ʼ */

	while( 1 ) 													 
	{
		/* U̻SDǷ,ȴ */
		printf( "Wait Udisk/SD\n" );
		while( CH378DiskConnect( ) != ERR_SUCCESS ) 
		{  
			mDelaymS( 100 );
		}
		mDelaymS( 200 );  										 /* ʱ,ѡ,еUSB洢Ҫʮʱ */
		
		/* ڼ⵽USB豸,ȴ100*50mS,ҪЩMP3̫,ڼ⵽USB豸DISK_MOUNTED,
		   ȴ5*50mS,ҪDiskReady */
		for( i = 0; i < 100; i ++ ) 
		{  
			/* ȴʱ,100*50mS */
			mDelaymS( 50 );
			printf( "Ready ?\n" );
			status = CH378DiskReady( );  						 /* ʼ̲ԴǷ */
			if( status == ERR_SUCCESS ) 
			{
				break;  										 /* ׼ */
			}
			else if( status == ERR_DISK_DISCON ) 
			{
				goto UnknownUsbDevice; 							 /* ⵽Ͽ,¼Ⲣʱ */
			}
			if( CH378GetDiskStatus( ) >= DEF_DISK_MOUNTED && i >= 5 ) 
			{
				break;  										 /* еUǷδ׼,Ժ,ֻҪ佨MOUNTEDҳ5*50mS */
			}
		}
		if( status == ERR_DISK_DISCON ) 
		{  
			/* ⵽Ͽ,¼Ⲣʱ */
			printf( "Device gone\n" );
			continue;
		}
		if( CH378GetDiskStatus( ) < DEF_DISK_MOUNTED ) 
		{  
			/* δ֪USB豸,USB̡ӡ */
			printf( "Unknown device\n" );
			goto UnknownUsbDevice;
		}
		
		/* Ҫ,ԶȡݿCH378_CMD_DATA.DiskMountInq,س */
		i = CH378ReadReqBlock( buf );
		if ( i == sizeof( INQUIRY_DATA ) ) 
		{  
			/* U̵ĳ̺ͲƷϢ */
			buf[ i ] = 0;
			printf( "Udisk Info: %s\n", ((P_INQUIRY_DATA)buf) -> VendorIdStr );
		}

		/* ȡǰUС(Ҫʹ) */
		SecterSize = 1 << CH378ReadVar8( VAR8_DISK_SEC_LEN );	 /* ǰUÿС */  

		/* öUеļĿ¼ */
		printf( "List all file \n" );
		status = ListAll( );  
		mStopIfError( status );	

UnknownUsbDevice:
		printf( "Take out\n" );
		while( CH378DiskConnect( ) == ERR_SUCCESS ) 
		{  
			/* UǷ,ȴṴγ */
			mDelaymS( 100 );
		}
		mDelaymS( 200 );
	}
}


