/********************************** (C) COPYRIGHT *******************************
* File Name          : FILE_SYS.C
* Author             : MJX
* Version            : V1.20
* Date               : 2015/11/25
* Description        : CH378оƬ ļϵͳ V1.2
*                      ṩļϵͳӳ,ṩ
*******************************************************************************/



/*******************************************************************************/
/* ˵: 
   (1)ʹõӳע͵,ӶԼƬĳROMռRAMռ;
   (2)ӳͨеıݲ,϶,Ϊ˽ԼRAM,
        ҲԲοCH375ӳĳͨͬһȫֱ/ϽṹCH378_CMD_DATA;
   (3)name ָļ, ԰Ŀ¼, ·ָ, ܳȲ1+8+1+3+1ֽ;
   (4)PathName ָȫ·Ķļ, Ŀ¼༶Ŀ¼·ָļ/Ŀ¼;	
   (5)LongName ָļ, UNICODEС˳, 0ֽڽ, ʹóļӳ */ 

/*******************************************************************************/
/* ֺ궨˵: 
   (1) NO_DEFAULT_CH378_INT ڽֹĬϵWait378Interruptӳ,ֹ,Ӧó
        жһͬӳ;
   (2) DEF_INT_TIMEOUT ĬϵWait378Interruptӳеĵȴжϵĳʱʱ/ѭ
        ֵ, 0򲻼鳬ʱһֱȴ;
   (3) EN_DISK_QUERY ṩѯʣռѯӳ,Ĭǲṩ;
   (4) EN_DIR_CREATE ṩ½༶Ŀ¼ӳ,Ĭǲṩ;
   (5) EN_SECTOR_ACCESS ṩΪλдļӳ,Ĭǲṩ;
   (6) EN_LONG_NAME ṩֳ֧ļӳ,Ĭǲṩ;
   (7) EN_OTHER_FUNCTION ṩǳӳ,Ĭǲṩ; */

/*******************************************************************************/
/* ͷļ */
#include "FILE_SYS.H"

/*******************************************************************************/
/*  */
UINT16 SectorSize = 512;										 /* ǰUÿС(ĬΪ512ֽ) */

/*******************************************************************************/
/* Ϊ */
/*******************************************************************************/

/*******************************************************************************
* Function Name  : CH378Read32bitDat
* Description    : CH378оƬȡ32λݲ
* Input          : None
* Output         : None
* Return         : 32λ
*******************************************************************************/
UINT32 CH378Read32bitDat( void )
{
	UINT8  c0, c1, c2, c3;

	c0 = xReadCH378Data( );
	c1 = xReadCH378Data( );
	c2 = xReadCH378Data( );
	c3 = xReadCH378Data( );
	xEndCH378Cmd( );
	return( c0 | (UINT16)c1 << 8 | (UINT32)c2 << 16 | (UINT32)c3 << 24 );
}

/*******************************************************************************
* Function Name  : CH378ReadVar8
* Description    : CH378оƬڲ8λ
* Input          : addr---8λַ
* Output         : None
* Return         : 8λ
*******************************************************************************/
UINT8 CH378ReadVar8( UINT8 addr ) 
{
	UINT8 dat;

	xWriteCH378Cmd( CMD11_READ_VAR8 );
	xWriteCH378Data( addr );
	dat = xReadCH378Data( );
	xEndCH378Cmd( );
	return( dat );
}

/*******************************************************************************
* Function Name  : CH378WriteVar8
* Description    : дCH378оƬڲ8λ
* Input          : addr---8λַ
*                  dat----8λֵ 
* Output         : None
* Return         : None
*******************************************************************************/
void CH378WriteVar8( UINT8 addr, UINT8 dat ) 
{
	xWriteCH378Cmd( CMD20_WRITE_VAR8 );
	xWriteCH378Data( addr );
	xWriteCH378Data( dat );
	xEndCH378Cmd( );
}

/*******************************************************************************
* Function Name  : CH378ReadVar32
* Description    : CH378оƬڲ32λ
* Input          : addr---32λַ
* Output         : None
* Return         : 32λ
*******************************************************************************/
UINT32 CH378ReadVar32( UINT8 addr )
{
	xWriteCH378Cmd( CMD14_READ_VAR32 );
	xWriteCH378Data( addr );
	return( CH378Read32bitDat( ) );  							 /* CH378оƬȡ32λݲ */
}

/*******************************************************************************
* Function Name  : CH378WriteVar32
* Description    : дCH378оƬڲ32λ
* Input          : addr---32λַ
*                  dat---32λֵ
* Output         : None
* Return         : None
*******************************************************************************/
void CH378WriteVar32( UINT8 addr, UINT32 dat ) 
{
	xWriteCH378Cmd( CMD50_WRITE_VAR32 );
	xWriteCH378Data( addr );
	xWriteCH378Data( (UINT8)dat );
	xWriteCH378Data( (UINT8)( (UINT16)dat >> 8 ) );
	xWriteCH378Data( (UINT8)( dat >> 16 ) );
	xWriteCH378Data( (UINT8)( dat >> 24 ) );
	xEndCH378Cmd( );
}

/*******************************************************************************
* Function Name  : CH378GetTrueLen
* Description    : ٷһִϺ󳤶Ӧʵʳ
* Input          : None
* Output         : None
* Return         : 32λ
*******************************************************************************/
UINT32 CH378GetTrueLen( void )
{
	UINT8  c0, c1, c2, c3;
	
	xWriteCH378Cmd( CMD02_GET_REAL_LEN );

	/* CH378оƬȡ32λݲ */  
	c0 = xReadCH378Data( );
	c1 = xReadCH378Data( );
	c2 = xReadCH378Data( );
	c3 = xReadCH378Data( );
	xEndCH378Cmd( );
	return( c0 | (UINT16)c1 << 8 | (UINT32)c2 << 16 | (UINT32)c3 << 24 );	
}

/*******************************************************************************
* Function Name  : CH378SetFileName
* Description    : ýҪļļ(·)
* Input          : PathName---Ҫõļ·
* Output         : None
* Return         : None
*******************************************************************************/
void CH378SetFileName( PUINT8 PathName ) 
{
	UINT8  i, c;

	if( PathName == NULL )										 /* ָΪ,ȥļ */
	{
		return;
	}	
	xWriteCH378Cmd( CMD10_SET_FILE_NAME );
	for( i = MAX_FILE_NAME_LEN; i != 0; --i ) 
	{
		c = *PathName;
		xWriteCH378Data( c );
		if( c == 0 ) 
		{
			break;
		}
		PathName ++;
	}
	xEndCH378Cmd( );
}

/*******************************************************************************
* Function Name  : CH378GetDiskStatus
* Description    : ȡ̺ļϵͳĹ״̬
* Input          : None
* Output         : None
* Return         : ظֵ
*******************************************************************************/
UINT8 CH378GetDiskStatus( void )  
{
	return( CH378ReadVar8( VAR8_DISK_STATUS ) );
}

/*******************************************************************************
* Function Name  : CH378GetIntStatus
* Description    : ȡж״̬ȡж
* Input          : None
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 CH378GetIntStatus( void ) 
{
	UINT8  s;

	xWriteCH378Cmd( CMD01_GET_STATUS );
	s = xReadCH378Data( );
	xEndCH378Cmd( );
	return( s );
}

/*******************************************************************************
* Function Name  : Wait378Interrupt
* Description    : ȴCH378ж(INT#͵ƽ)
* Input          : None
* Output         : None
* Return         : ж״̬, ʱ򷵻ERR_USB_UNKNOWN
*******************************************************************************/
#ifndef	NO_DEFAULT_CH378_INT

UINT8 Wait378Interrupt( void ) 
{
#ifdef DEF_INT_TIMEOUT

#if	DEF_INT_TIMEOUT < 1
	while( Query378Interrupt( ) == FALSE );  					 /* һֱж */
	return( CH378GetIntStatus( ) );  							 /* ⵽ж */
#else
	UINT32 i;

	for( i = 0; i < DEF_INT_TIMEOUT; i ++ ) 
	{  
		/* ֹʱ */
		if( Query378Interrupt( ) ) 
		{
			return( CH378GetIntStatus( ) );  					 /* ⵽ж */
		}
		mDelayuS( 3 );
		/* ڵȴCH378жϵĹ,ЩҪʱ */
	}
	return( ERR_USB_UNKNOWN );  								 /* Ӧ÷ */
#endif

#else
	UINT32 i;

	for( i = 0; i < 5000000; i ++ ) 
	{  
		/* ֹʱ,Ĭϵĳʱʱ,뵥ƬƵй */
		if ( Query378Interrupt( ) ) 
		{
			return( CH378GetIntStatus( ) );  					 /* ⵽ж */
		}
		mDelayuS( 3 );
		 
		/* ڵȴCH378жϵĹ,ЩҪʱ */
	}
	return( ERR_USB_UNKNOWN );  								 /* Ӧ÷ */
#endif
}
#endif

/*******************************************************************************
* Function Name  : CH378SendCmdWaitInt
* Description    : ,ȴж
* Input          : mCmd---Ҫִе
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 CH378SendCmdWaitInt( UINT8 mCmd )  
{
	xWriteCH378Cmd( mCmd );
	xEndCH378Cmd( );
	return( Wait378Interrupt( ) );
}

/*******************************************************************************
* Function Name  : CH378SendCmdDatWaitInt
* Description    : һֽݺ,ȴж
* Input          : mCmd---Ҫִе
*                  mDat---1ֽڲ
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 CH378SendCmdDatWaitInt( UINT8 mCmd, UINT8 mDat )
{
	xWriteCH378Cmd( mCmd );
	xWriteCH378Data( mDat );
	xEndCH378Cmd( );
	return( Wait378Interrupt( ) );
}

/*******************************************************************************
* Function Name  : CH378GetFileSize
* Description    : ȡǰļ
* Input          : None
* Output         : None
* Return         : صǰļ
*******************************************************************************/
UINT32 CH378GetFileSize( void ) 
{
	return( CH378ReadVar32( VAR32_FILE_SIZE ) );
}

/*******************************************************************************
* Function Name  : CH378SetFileSize
* Description    : õǰļ
*                  ע: úõǰļ,ʱ޸ĵǰļ
*                        ĳ,ԱĳЩ,ȡļһ
* Input          : filesize---ļ
* Output         : None
* Return         : None
*******************************************************************************/
void CH378SetFileSize( UINT32 filesize ) 
{
	CH378WriteVar32( VAR32_FILE_SIZE, filesize );
}

/*******************************************************************************
* Function Name  : CH378DiskConnect
* Description    : U/SDǷ
* Input          : None
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 CH378DiskConnect( void )  
{
	if( Query378Interrupt( ) ) 
	{
		CH378GetIntStatus( );  									 /* ⵽ж */
	}
	return( CH378SendCmdWaitInt( CMD0H_DISK_CONNECT ) );
}

/*******************************************************************************
* Function Name  : CH378DiskReady
* Description    : ʼ̲ԴǷ
* Input          : None
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 CH378DiskReady( void )  
{
	return( CH378SendCmdWaitInt( CMD0H_DISK_MOUNT ) );
}

/*******************************************************************************
* Function Name  : CH378ReadReqBlock
* Description    : ӵǰ˵Ľջȡݿ
* Input          : buf---ݻ	
* Output         : None
* Return         : س
*******************************************************************************/
UINT16 CH378ReadReqBlock( PUINT8 buf ) 
{
	UINT16 len;
	UINT16 l;
	
	xWriteCH378Cmd( CMD00_RD_HOST_REQ_DATA );					 /* д1ֽ */		
	len = xReadCH378Data( );
	len += ( ( UINT16 )xReadCH378Data( ) << 8 );				 /* ȡ2ֽݳ */
	mDelayuS( 1 ); 												 /* ڸMCU,ڴ˴ʵʱ */		
	l = len;
	if( len )
	{
		do
		{		
			*buf = xReadCH378Data( );	
			buf++;
		}while( --l );		
	}
	xEndCH378Cmd( );
	return( len );
}

/*******************************************************************************
* Function Name  : CH378ReadBlock
* Description    : ӵǰ˵Ľջȡݿ
* Input          : buf---ݻ
*				   len---ȡ	
* Output         : None
* Return         : س
*******************************************************************************/
UINT16 CH378ReadBlock( PUINT8 buf, UINT16 len ) 
{
	UINT16 l;
	
	xWriteCH378Cmd( CMD20_RD_HOST_CUR_DATA );					 /* д1ֽ */		
	xWriteCH378Data( ( UINT8 )len );							 
	xWriteCH378Data( len >> 8 );								 /* д2ֽݳ */	
	mDelayuS( 1 ); 												 /* ڸMCU,ڴ˴ʵʱ */
	if( len )
	{
		l = len;
		do
		{
			*buf = xReadCH378Data( );
			buf++;
		}while( --l );		
	}
	xEndCH378Cmd( );
	return( len );
}

/*******************************************************************************
* Function Name  : CH378ReadOfsBlock
* Description    : ȡڲָָƫƵַݿ(ڲָԶ)
* Input          : buf---ݻ
*				   offset---ƫƵַ	
*				   len---ȡ	
* Output         : None
* Return         : س
*******************************************************************************/
UINT16 CH378ReadOfsBlock( PUINT8 buf, UINT16 offset, UINT16 len ) 
{
	UINT16 l;
	
	xWriteCH378Cmd( CMD40_RD_HOST_OFS_DATA );					 /* д1ֽ */
	xWriteCH378Data( ( UINT8 )offset );							 /* д2ֽƫƵַ */			
	xWriteCH378Data( offset >> 8 );							
	xWriteCH378Data( ( UINT8 )len );							 /* д2ֽݳ */
	xWriteCH378Data( len >> 8 );
	mDelayuS( 1 ); 												 /* ڸMCU,ڴ˴ʵʱ */							
	if( len )
	{
		l = len;
		do
		{
			*buf = xReadCH378Data( );
			buf++;
		}while( --l );		
	}
	xEndCH378Cmd( );
	return( len );
}

/*******************************************************************************
* Function Name  : CH378WriteBlock
* Description    : ڲָǰƫƵַдݿ(ڲָԶ)
* Input          : buf---ݻ
*				   len---дݳ	
* Output         : None
* Return         : س
*******************************************************************************/
UINT16 CH378WriteBlock( PUINT8 buf, UINT16 len ) 
{
	UINT16 l;
	
	xWriteCH378Cmd( CMD20_WR_HOST_CUR_DATA );					 /* д1ֽ */		
	xWriteCH378Data( ( UINT8 )len );							 /* д2ֽݳ */
	xWriteCH378Data( len >> 8 );	
	mDelayuS( 1 ); 												 /* ڸMCU,ڴ˴ʵʱ */						
	if( len )
	{
		l = len;
		do
		{
			xWriteCH378Data( *buf );
			buf++;
		}while( --l );		
	}
	xEndCH378Cmd( );
	return( len );
}

/*******************************************************************************
* Function Name  : CH378WriteOfsBlock
* Description    : ڲָָƫƵַдݿ(ڲָԶ)
* Input          : buf---ݻ
*				   offset---ƫƵַ
*				   len---дݳ	
* Output         : None
* Return         : س
*******************************************************************************/
UINT16 CH378WriteOfsBlock( PUINT8 buf, UINT16 offset, UINT16 len ) 
{
	UINT16 l;
	
	xWriteCH378Cmd( CMD40_WR_HOST_OFS_DATA );					 /* д1ֽ */		
	xWriteCH378Data( ( UINT8 )offset );							 /* д2ֽƫƵַ */			
	xWriteCH378Data( offset >> 8 );							
	xWriteCH378Data( ( UINT8 )len );							 /* д2ֽݳ */
	xWriteCH378Data( len >> 8 );
	mDelayuS( 1 ); 												 /* ڸMCU,ڴ˴ʵʱ */							
	if( len )
	{
		l = len;
		do
		{
			xWriteCH378Data( *buf );
			buf++;
		}while( --l );		
	}
	xEndCH378Cmd( );
	return( len );
}

/*******************************************************************************
* Function Name  : CH378FileOpen
* Description    : ļĿ¼(ļ)
* Input          : PathName---Ҫ򿪵ļĿ¼·
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 CH378FileOpen( PUINT8 PathName )  
{
	CH378SetFileName( PathName );  								 /* ýҪļļ */
	return( CH378SendCmdWaitInt( CMD0H_FILE_OPEN ) );	
}

/*******************************************************************************
* Function Name  : CH378FileCreate
* Description    : ½ļ,ļѾôɾ½
* Input          : PathName---Ҫ½ļ·ļ
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 CH378FileCreate( PUINT8 PathName ) 
{
	CH378SetFileName( PathName );  								 /* ýҪļļ */
	return( CH378SendCmdWaitInt( CMD0H_FILE_CREATE ) );
}

/*******************************************************************************
* Function Name  : CH378FileErase
* Description    : ɾļر
*                  ɾļ,Ѿֱɾ,ļȴɾ,ֶ֧༶Ŀ¼· 
* Input          : PathName---ɾļ·ļ
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 CH378FileErase( PUINT8 PathName ) 
{
	CH378SetFileName( PathName );  
	return( CH378SendCmdWaitInt( CMD0H_FILE_ERASE ) );
}

/*******************************************************************************
* Function Name  : CH378FileClose
* Description    : رյǰѾ򿪵ļĿ¼(ļ)
* Input          : UpdateSz---0---Զļ; 1---Զļ
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 CH378FileClose( UINT8 UpdateSz ) 
{
	return( CH378SendCmdDatWaitInt( CMD1H_FILE_CLOSE, UpdateSz ) );
}

/*******************************************************************************
* Function Name  : CH378ByteLocate
* Description    : ֽΪλƶǰļָ
* Input          : offset---ƫֽ
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 CH378ByteLocate( UINT32 offset ) 
{
	xWriteCH378Cmd( CMD4H_BYTE_LOCATE );
	xWriteCH378Data( (UINT8)offset );
	xWriteCH378Data( (UINT8)( (UINT16)offset >> 8 ) );
	xWriteCH378Data( (UINT8)( offset >> 16 ) );
	xWriteCH378Data( (UINT8)( offset >> 24 ) );
	xEndCH378Cmd( );
	return( Wait378Interrupt( ) );
}

/*******************************************************************************
* Function Name  : CH378ByteRead
* Description    : ֽΪλӵǰλöȡݿ
* Input          : buf---
*				   ReqCount----Ҫȡݳ
*				   RealCount---ʵʶȡݳ	
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 CH378ByteRead( PUINT8 buf, UINT16 ReqCount, PUINT16 RealCount ) 
{
	UINT8  s;
	UINT16 len;

	/* ֽڶȡ */		
	xWriteCH378Cmd( CMD2H_BYTE_READ );							 /* һֽ */
	xWriteCH378Data( (UINT8)ReqCount );
	xWriteCH378Data( (UINT8)( ReqCount >> 8 ) );				 /* ֽݳ */
	xEndCH378Cmd( );
	if( RealCount ) 
	{
		*RealCount = 0;
	}
	s = Wait378Interrupt( );
	if( s == ERR_SUCCESS )
	{
		/* ȡʵʳ */
		len = CH378GetTrueLen(  );							 	 /* ǰִкʵʷس */
		if( RealCount ) 
		{
			*RealCount = len;
		}
		
		/* ʵʿɶȡȶȡ */
		if( len )
		{	
			CH378ReadBlock( buf, len );		
		}				
	}
	return( s );	
}

/*******************************************************************************
* Function Name  : CH378ByteReadPrepare
* Description    : ֽΪλӵǰλöȡݿ׼
*                  ע⣺CH378ByteReadֻͶȡִ,δȡ,
*                        úִϺ,ʵȻCH378ڲ20K
* Input          : ReqCount----Ҫȡݳ
*				   RealCount---ʵʶȡݳ	
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 CH378ByteReadPrepare( UINT16 ReqCount, PUINT16 RealCount ) 
{
	UINT8  s;
	UINT16 len;

	/* ֽڶȡ */		
	xWriteCH378Cmd( CMD2H_BYTE_READ );							 /* һֽ */
	xWriteCH378Data( (UINT8)ReqCount );
	xWriteCH378Data( (UINT8)( ReqCount >> 8 ) );				 /* ֽݳ */
	xEndCH378Cmd( );
	if( RealCount ) 
	{
		*RealCount = 0;
	}
	s = Wait378Interrupt( );
	if( s == ERR_SUCCESS )
	{
		/* ȡʵʳ */
		len = CH378GetTrueLen(  );							 	 /* ǰִкʵʷس */
		if( RealCount ) 
		{
			*RealCount = len;
		}
	}
	return( s );	
}

/*******************************************************************************
* Function Name  : CH378ByteWrite
* Description    : ֽΪλǰλдݿ
* Input          : buf---
*				   ReqCount----Ҫдݳ
*				   RealCount---ʵдݳ	
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 CH378ByteWrite( PUINT8 buf, UINT16 ReqCount, PUINT16 RealCount )  
{
	UINT8  s;

	/* ҪдԤ͵ڲ */
	CH378WriteOfsBlock( buf, 0x0000, ReqCount );

	/* ֽд */		
	xWriteCH378Cmd( CMD2H_BYTE_WRITE );
	xWriteCH378Data( (UINT8)ReqCount );
	xWriteCH378Data( (UINT8)( ReqCount >> 8 ) );
	xEndCH378Cmd( );
	s = Wait378Interrupt( );
	if( s != ERR_SUCCESS )
	{
		if( RealCount ) 
		{
			*RealCount = 0;
		}		
	}
	else
	{
		if( RealCount ) 
		{
			*RealCount = ReqCount;
		}				
	}	
	return( s );
}

/*******************************************************************************
* Function Name  : CH378ByteWriteExecute
* Description    : ֽΪλǰλдݿ
*                  ע⣺CH378ByteWrite,úִǰ,ѾǰŵCH378ڲ20K
*                        ָ
* Input          : ReqCount----Ҫдݳ
*				   RealCount---ʵдݳ	
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 CH378ByteWriteExecute( UINT16 ReqCount, PUINT16 RealCount )  
{
	UINT8  s;

	/* ֽд */		
	xWriteCH378Cmd( CMD2H_BYTE_WRITE );
	xWriteCH378Data( (UINT8)ReqCount );
	xWriteCH378Data( (UINT8)( ReqCount >> 8 ) );
	xEndCH378Cmd( );
	s = Wait378Interrupt( );
	if( s != ERR_SUCCESS )
	{
		if( RealCount ) 
		{
			*RealCount = 0;
		}		
	}
	else
	{
		if( RealCount ) 
		{
			*RealCount = ReqCount;
		}				
	}	
	return( s );
}

/*******************************************************************************
* Function Name  : CH378FileQuery
* Description    : CH378ѯǰļϢ(ȡڡʱ䡢)
*                  9ֽݣֱΪ4ֽڳȡ2ֽڡ2ֽʱ䡢
*                  ֽ1 
* Input          : buf---ݻ
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 CH378FileQuery( PUINT8 buf ) 
{
	UINT8  status;
	
	status = CH378SendCmdWaitInt( CMD0H_FILE_QUERY );
	if( status != ERR_SUCCESS )
	{
		return( status );
	}

	CH378ReadReqBlock( buf );
	return( status );
}	

/*******************************************************************************
* Function Name  : CH378FileModify
* Description    : CH378޸ĵǰļϢ(ȡڡʱ䡢)
* Input          : filesize----µļ,Ϊ0xFFFFFFFF޸
*				   filedate----µļ,Ϊ0xFFFF޸
*				   filetime----µļʱ,Ϊ0xFFFF޸	
*                  fileattr----µļ,Ϊ0xFF޸
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 CH378FileModify( UINT32 filesize, UINT16 filedate, UINT16 filetime, UINT8 fileattr ) 
{	
	xWriteCH378Cmd( CMD40_WR_HOST_OFS_DATA );					 /* д1ֽ */		
	xWriteCH378Data( 0x00 );							 		 /* д2ֽƫƵַ */			
	xWriteCH378Data( 0x00 );							
	xWriteCH378Data( 0x09 );							 		 /* д2ֽݳ */
	xWriteCH378Data( 0x00 );								
	xWriteCH378Data( (UINT8)filesize );  						 /* д4ֽµļ */					 
	xWriteCH378Data( (UINT8)( filesize >> 8 ) );
	xWriteCH378Data( (UINT8)( filesize >> 16 ) );
	xWriteCH378Data( (UINT8)( filesize >> 24 ) ); 	 		 
	xWriteCH378Data( (UINT8)filedate );  						 /* д2ֽµļ */					 
	xWriteCH378Data( (UINT8)( filedate >> 8 ) );
	xWriteCH378Data( (UINT8)filetime );  						 /* д2ֽµļʱ */					 
	xWriteCH378Data( (UINT8)( filetime >> 8 ) );
	xWriteCH378Data( (UINT8)fileattr );  						 /* д1ֽµļ */					 
	xEndCH378Cmd( );	
	return( CH378SendCmdWaitInt( CMD0H_FILE_MODIFY ) );
}	

/*******************************************************************************
* Function Name  : CH378DirInfoRead
* Description    : ȡǰļָĵĿ¼Ϣ
* Input          : index---Ŀ¼Ϣṹе
*                  ŷΧΪ00H--0FHȡжӦĵǰĿ¼Ϣṹ
*                  ΪFFH         ȡǰ򿪵ļڵĿ¼Ϣṹ
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 CH378DirInfoRead( UINT8 index ) 
{
	return( CH378SendCmdDatWaitInt( CMD1H_DIR_INFO_READ, index ) );
}

/*******************************************************************************
* Function Name  : CH378DirInfoSave
* Description    : 浱ǰļָĵĿ¼Ϣ
* Input          : index---Ŀ¼Ϣṹе
*                  ŷΧΪ00H--0FHжӦĵǰĿ¼Ϣṹ
*                  ΪFFH         浱ǰ򿪵ļڵĿ¼Ϣṹ
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 CH378DirInfoSave( UINT8 index )  
{
	return( CH378SendCmdDatWaitInt( CMD1H_DIR_INFO_SAVE, index ) );
}

/**********************************************************************************************************/
/* Ϊ,ͨEN_SECTOR_ACCESSرջ */
/**********************************************************************************************************/

#ifdef	EN_SECTOR_ACCESS

/*******************************************************************************
* Function Name  : CH378SecLocate
* Description    : Ϊλƶǰļָ
* Input          : offset---ƫ
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 CH378SecLocate( UINT32 offset )
{
	xWriteCH378Cmd( CMD4H_SEC_LOCATE );
	xWriteCH378Data( (UINT8)offset );
	xWriteCH378Data( (UINT8)((UINT16)offset >> 8 ) );
	xWriteCH378Data( (UINT8)( offset >> 16 ) );
	xWriteCH378Data( 0 );  										 /* ļߴ */
	xEndCH378Cmd( );
	return( Wait378Interrupt( ) );
}

/*******************************************************************************
* Function Name  : CH378SecRead
* Description    : Ϊλӵǰļλöȡݿ
* Input          : buf---ݻ
*                  ReqCount------׼ȡ
*                  RealCount-----ʵʶȡ
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 CH378SecRead( PUINT8 buf, UINT8 ReqCount, PUINT8 RealCount ) 
{
	UINT8  s, count;
	UINT8  maxnum;
	UINT16 len, l;

	s = 0;
	if( RealCount ) 
	{
		*RealCount = 0;
	}	
	maxnum = MAX_BYTE_PER_OPERATE / SectorSize; 				 /* 㵱οԶȡĿ */
	
	/* ѭȡ */
	while( ReqCount )
	{
		/* 㵥ζȡ */
		if( ReqCount >= maxnum )
		{
			count = maxnum;
			ReqCount = ReqCount - count;			
		}
		else
		{
			count = ReqCount;
			ReqCount = 0;			
		}

		/* Ͷȡ */		
		xWriteCH378Cmd( CMD1H_SEC_READ );
		xWriteCH378Data( count );
		xEndCH378Cmd( );
		s = Wait378Interrupt( );  								 /* ȴжϲȡ״̬ */
		if( s != ERR_SUCCESS )
		{
			return( s );
		}					

		/* ȡʵʿɶȡֽ */
		count = CH378GetTrueLen(  );							 /* ǰִкʵʷس */			
		len = count * SectorSize;	

		/* ȡݵָ */
//		CH378ReadBlock( buf, len );  							 /* 滻ٶ */		
		xWriteCH378Cmd( CMD20_RD_HOST_CUR_DATA );				 /* д1ֽ */		
		xWriteCH378Data( ( UINT8 )len );							 
		xWriteCH378Data( len >> 8 );							 /* д2ֽݳ */	
		mDelayuS( 1 ); 											 /* ڸMCU,ڴ˴ʵʱ */	
		
		/* Ż²ִ߶ٶ */
		l = len;
		while( l )
		{
			*buf++ = xReadCH378Data( );			   					
			*buf++ = xReadCH378Data( );
			*buf++ = xReadCH378Data( );
			*buf++ = xReadCH378Data( );
			*buf++ = xReadCH378Data( );
			*buf++ = xReadCH378Data( );
			*buf++ = xReadCH378Data( );
			*buf++ = xReadCH378Data( );
			*buf++ = xReadCH378Data( );
			*buf++ = xReadCH378Data( );
			*buf++ = xReadCH378Data( );
			*buf++ = xReadCH378Data( );
			*buf++ = xReadCH378Data( );
			*buf++ = xReadCH378Data( );
			*buf++ = xReadCH378Data( );
			*buf++ = xReadCH378Data( );
			l = l - 16;
		}
		xEndCH378Cmd( );
		buf	= buf + len;						
		if( RealCount ) 
		{
			*RealCount += count;
		}		
		if( count < maxnum )									 /* ȡļĩβ,ǰ */		
		{
			return( s );
		}				
	}
	return( s );
}

/*******************************************************************************
* Function Name  : CH378SecWrite
* Description    : Ϊλڵǰλдݿ
*                  ע: дΪ0,CH378ڲԶļ 
* Input          : buf---ݻ
*                  ReqCount------׼д
*                  RealCount-----ʵд
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 CH378SecWrite( PUINT8 buf, UINT8 ReqCount, PUINT8 RealCount ) 
{
	UINT8  s, count;
	UINT8  maxnum;
	UINT16 len, l;

	if( RealCount ) 
	{
		*RealCount = 0;
	}	
	maxnum = MAX_BYTE_PER_OPERATE / SectorSize; 				 /* 㵱οԶȡĿ */
	
	/* ѭд */
	do
	{
		/* 㵥д */
		if( ReqCount >= maxnum )
		{
			count = maxnum;
			ReqCount = ReqCount - count;			
		}
		else
		{
			count = ReqCount;
			ReqCount = 0;			
		}

		/* ҪдԤ͵ڲ */
		len = count * SectorSize;

		/* Ż˲ִ߶ٶ */
//		CH378WriteOfsBlock( buf, 0x00, len );						 /* 滻ٶ */
		xWriteCH378Cmd( CMD40_WR_HOST_OFS_DATA );					 /* д1ֽ */		
		xWriteCH378Data( 0x00 );									 /* д2ֽƫƵַ */			
		xWriteCH378Data( 0x00 );							
		xWriteCH378Data( ( UINT8 )len );							 /* д2ֽݳ */
		xWriteCH378Data( len >> 8 );							
		l = len;
		while( l )
		{
			xWriteCH378Data( *buf++ );
			xWriteCH378Data( *buf++ );
			xWriteCH378Data( *buf++ );
			xWriteCH378Data( *buf++ );
			xWriteCH378Data( *buf++ );
			xWriteCH378Data( *buf++ );
			xWriteCH378Data( *buf++ );
			xWriteCH378Data( *buf++ );
			xWriteCH378Data( *buf++ );
			xWriteCH378Data( *buf++ );
			xWriteCH378Data( *buf++ );
			xWriteCH378Data( *buf++ );
			xWriteCH378Data( *buf++ );
			xWriteCH378Data( *buf++ );
			xWriteCH378Data( *buf++ );
			xWriteCH378Data( *buf++ );
			l = l - 16;
		}
		xEndCH378Cmd( );
		buf	= buf + len;

		/* д */
		xWriteCH378Cmd( CMD1H_SEC_WRITE );
		xWriteCH378Data( count );
		xEndCH378Cmd( );
		s = Wait378Interrupt( );  								 /* ȴжϲȡ״̬ */
		if( s != ERR_SUCCESS )
		{
			return( s );
		}
		if( RealCount ) 
		{
			*RealCount += count;
		}		
	}while( ReqCount );
	return( s );
}

/*******************************************************************************
* Function Name  : CH378DiskReadSec
* Description    : U̶ȡݿ鵽
* Input          : buf---ݻ
*                  iLbaStart------׼ȡʼ
*                  iSectorCount---׼ȡ
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 CH378DiskReadSec( PUINT8 buf, UINT32 iLbaStart, UINT8 iSectorCount ) 
{	
	UINT8  s, count;
	UINT8  maxnum;
	UINT16 len;
	UINT32 seclba;	

	s = 0;
	seclba = iLbaStart;
	maxnum = MAX_BYTE_PER_OPERATE / SectorSize; 				 /* 㵱οԶȡĿ */

	/* ѭȡ */
	while( iSectorCount )
	{
		/* 㵥ζȡ */
		if( iSectorCount >= maxnum )
		{
			count = maxnum;
			iSectorCount = iSectorCount - count;			
		}
		else
		{
			count = iSectorCount;
			iSectorCount = 0;			
		}
	
		/* Ͷȡ */		
		xWriteCH378Cmd( CMD5H_DISK_READ );  					 /* USB洢 */
		xWriteCH378Data( (UINT8)seclba );  						 /* LBA8λ */
		xWriteCH378Data( (UINT8)( (UINT16)seclba >> 8 ) );
		xWriteCH378Data( (UINT8)( seclba >> 16 ) );
		xWriteCH378Data( (UINT8)( seclba >> 24 ) ); 	 		 /* LBA8λ */
		xWriteCH378Data( count );  							 	 /*  */
		xEndCH378Cmd( );
		s = Wait378Interrupt( );  								 /* ȴжϲȡ״̬ */
		if( s != ERR_SUCCESS )
		{
			return( s );
		}					
		
		/* ȡݵָ */
		len = count * SectorSize;
		CH378ReadBlock( buf, len );
		buf	= buf + len;		
		seclba = seclba + count;	
	}
	return( s );
}

/*******************************************************************************
* Function Name  : CH378DiskWriteSec
* Description    : еĶݿдU
* Input          : buf---ݻ
*                  iLbaStart------дʼ
*                  iSectorCount---׼д
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 CH378DiskWriteSec( PUINT8 buf, UINT32 iLbaStart, UINT8 iSectorCount )  
{	
	UINT8  s, count;
	UINT8  maxnum;
	UINT16 len;
	UINT32 seclba;
	
	s = 0;
	seclba = iLbaStart;
	maxnum = MAX_BYTE_PER_OPERATE / SectorSize; 				 /* 㵱οԶȡĿ */

	/* ѭд */
	while( iSectorCount )
	{
		/* 㵥д */
		if( iSectorCount >= maxnum )
		{
			count = maxnum;
			iSectorCount = iSectorCount - count;			
		}
		else
		{
			count = iSectorCount;
			iSectorCount = 0;			
		}	

		/* ҪдԤ͵ڲ */
		len = count * SectorSize;
		CH378WriteOfsBlock( buf, 0x00, len );
		buf	= buf + len;
				
		/* д */
		xWriteCH378Cmd( CMD5H_DISK_WRITE );  					 /* USB洢д */
		xWriteCH378Data( (UINT8)seclba );  						 /* LBA8λ */
		xWriteCH378Data( (UINT8)( (UINT16)seclba >> 8 ) );
		xWriteCH378Data( (UINT8)( seclba >> 16 ) );
		xWriteCH378Data( (UINT8)( seclba >> 24 ) );  			 /* LBA8λ */
		xWriteCH378Data( count );  								 /*  */
		xEndCH378Cmd( );		
		s = Wait378Interrupt( );  								 /* ȴжϲȡ״̬ */
		if( s != ERR_SUCCESS )
		{
			return( s );
		}
		seclba = seclba + count;		
	}
	return( s );
}

#endif

/**********************************************************************************************************/
/* Ϊ̲ѯ,ͨEN_DISK_QUERYرջ */
/**********************************************************************************************************/

#ifdef	EN_DISK_QUERY

/*******************************************************************************
* Function Name  : CH378DiskCapacity
* Description    : ѯ()
* Input          : DiskCap---
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 CH378DiskCapacity( PUINT32 DiskCap )  
{
	UINT8  s;
	
	s = CH378SendCmdWaitInt( CMD0H_DISK_CAPACITY );
	if ( s == ERR_SUCCESS ) 
	{  
		xWriteCH378Cmd( CMD00_RD_HOST_REQ_DATA );				 /* д1ֽ */		
		xReadCH378Data( );							
		xReadCH378Data( );						 	
		*DiskCap = CH378Read32bitDat( );  						 /* CH378оƬȡ32λݲ */
	}
	else 
	{
		*DiskCap = 0;
	}
	return( s );
}

/*******************************************************************************
* Function Name  : CH378DiskQuery
* Description    : ѯʣռϢ()
* Input          : DiskFre---
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 CH378DiskQuery( PUINT32 DiskFre )  
{
	UINT8  s;
	UINT8  c0, c1, c2, c3;

	s = CH378SendCmdWaitInt( CMD0H_DISK_QUERY );
	if( s == ERR_SUCCESS ) 
	{  		
		xWriteCH378Cmd( CMD00_RD_HOST_REQ_DATA );				 /* д1ֽ */		
		xReadCH378Data( );							
		xReadCH378Data( );						 		 	     /* ȡ2ֽݳ */		
				
		xReadCH378Data( );  									 /* CH378_CMD_DATA.DiskQuery.mTotalSector */
		xReadCH378Data( );
		xReadCH378Data( );
		xReadCH378Data( );

		c0 = xReadCH378Data( );  								 /* CH378_CMD_DATA.DiskQuery.mFreeSector */
		c1 = xReadCH378Data( );
		c2 = xReadCH378Data( );
		c3 = xReadCH378Data( );
		*DiskFre = c0 | (UINT16)c1 << 8 | (UINT32)c2 << 16 | (UINT32)c3 << 24;
		xReadCH378Data( );  									 /* CH378_CMD_DATA.DiskQuery.mDiskFat */
		xEndCH378Cmd( );
	}
	else 
	{
		*DiskFre = 0;
	}
	return( s );
}

#endif

/**********************************************************************************************************/
/* ΪĿ¼,ͨEN_DIR_CREATEرջ */
/**********************************************************************************************************/

#ifdef	EN_DIR_CREATE

/*******************************************************************************
* Function Name  : CH378DirCreate
* Description    : ڸĿ¼½Ŀ¼(ļ),Ŀ¼ѾôֱӴ
* Input          : PathName---Ҫļе·ļ
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 CH378DirCreate( PUINT8 PathName ) 
{
	CH378SetFileName( PathName );  								 /* ýҪļеļ */
	return( CH378SendCmdWaitInt( CMD0H_DIR_CREATE ) );
}
#endif

/**********************************************************************************************************/
/* Ϊļ,ͨEN_LONG_NAMEرջ */
/**********************************************************************************************************/

#ifdef	EN_LONG_NAME

/*******************************************************************************
* Function Name  : CH378GetLongName
* Description    : ɶļĿ¼(ļ)Ӧĳļ
*                  Ҫļ·PathName
* Input          : PathName---ļ·
* Output         : LongName---صĳļ,UNICODEС˱,˫0
* Return         : ж״̬
*******************************************************************************/
UINT8 CH378GetLongName( PUINT8 PathName, PUINT8 LongName )
{
	UINT8  status;	
	
	CH378SetFileName( PathName );  								 /* ýҪļ· */
	status = CH378SendCmdWaitInt( CMD10_GET_LONG_FILE_NAME );
	if( status == ERR_SUCCESS )
	{
		/* ݷ,ȡ */
		CH378ReadReqBlock( LongName );
	}
	return( status );		
}

/*******************************************************************************
* Function Name  : CH378GetShortName
* Description    : ɶļĿ¼(ļ)·ļӦĶļ
* Input          : LongName---ĳļ,UNICODEС˱,˫0
* Output         : PathName---ļ·
* Return         : ж״̬
*******************************************************************************/
UINT8 CH378GetShortName( PUINT8 PathName, PUINT8 LongName )
{
	UINT8  status;	
	UINT16	count;

	/* ýҪĶļ· */	
	CH378SetFileName( PathName );  								 /* ýҪļĲ· */

	/* óļ */
	for( count = 0; count < LONG_NAME_BUF_LEN; count += 2 ) 
	{
		if ( *(PUINT16)( &LongName[ count ] ) == 0 ) 
		{
			break;  											 /* λ */
		}
	}
	if( ( count == 0 ) || ( count >= LONG_NAME_BUF_LEN ) || ( count > LONE_NAME_MAX_CHAR ) ) 
	{
		return( ERR_LONG_NAME_ERR );  							 /* ļЧ */
	}	
	count = count + 2;											 /* ļֽΪ0x00 */		
	xWriteCH378Cmd( CMD10_SET_LONG_FILE_NAME );					 /* д1ֽ */		
	xWriteCH378Data( ( UINT8 )count );							 /* д2ֽݳ */
	xWriteCH378Data( count >> 8 );							
	do
	{
		xWriteCH378Data( *LongName++ );
	}while( --count );		
	xEndCH378Cmd( );

	/* ȡӦĶļ */
	status = CH378SendCmdWaitInt( CMD1H_GET_SHORT_FILE_NAME );
	if( status == ERR_SUCCESS )
	{
		/* ݷ,ȡ */
		CH378ReadReqBlock( PathName );
	}
	return( status );		
}

/*******************************************************************************
* Function Name  : CH378CreateLongName
* Description    : ½гļļ
*                  Ҫļ·PathName(ȲοFAT淶ɳļв),
*                  ҪUNICODEС˱˫0ĳļLongName
* Input          : PathName---ļ·
*                  LongName---UNICODEС˱˫0ĳļ
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 CH378CreateLongName( PUINT8 PathName, PUINT8 LongName )  
{
	UINT16	count;			
	
	/* ýҪĶļ· */
	CH378SetFileName( PathName );  								 
	
	/* óļ */
	for( count = 0; count < LONG_NAME_BUF_LEN; count += 2 ) 
	{
		if ( *(PUINT16)( &LongName[ count ] ) == 0 ) 
		{
			break;  											 /* λ */
		}
	}
	if( ( count == 0 ) || ( count >= LONG_NAME_BUF_LEN ) || ( count > LONE_NAME_MAX_CHAR ) ) 
	{
		return( ERR_LONG_NAME_ERR );  							 /* ļЧ */
	}	
	count = count + 2;											 /* ļֽΪ0x00 */		
	xWriteCH378Cmd( CMD10_SET_LONG_FILE_NAME );					 /* д1ֽ */		
	xWriteCH378Data( ( UINT8 )count );							 /* д2ֽݳ */
	xWriteCH378Data( count >> 8 );							
	do
	{
		xWriteCH378Data( *LongName++ );
	}while( --count );		
	xEndCH378Cmd( );	
	
	/* ִдļ */
	return( CH378SendCmdWaitInt( CMD0H_LONG_FILE_CREATE ) );
}

/*******************************************************************************
* Function Name  : CH378CreateLongDir
* Description    : ½гļĿ¼
* Input          : PathName---ļ·
*                  LongName---UNICODEС˱˫0ĳļ
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 CH378CreateLongDir( PUINT8 PathName, PUINT8 LongName )  
{
	UINT16	count;			

	/* ýҪĶļ· */	
	CH378SetFileName( PathName );  								
	
	/* óļ */
	for( count = 0; count < LONG_NAME_BUF_LEN; count += 2 ) 
	{
		if ( *(PUINT16)( &LongName[ count ] ) == 0 ) 
		{
			break;  											 /* λ */
		}
	}
	if( ( count == 0 ) || ( count >= LONG_NAME_BUF_LEN ) || ( count > LONE_NAME_MAX_CHAR ) ) 
	{
		return( ERR_LONG_NAME_ERR );  							 /* ļЧ */
	}	
	count = count + 2;											 /* ļֽΪ0x00 */		
	xWriteCH378Cmd( CMD10_SET_LONG_FILE_NAME );					 /* д1ֽ */		
	xWriteCH378Data( ( UINT8 )count );							 /* д2ֽݳ */
	xWriteCH378Data( count >> 8 );							
	do
	{
		xWriteCH378Data( *LongName++ );
	}while( --count );		
	xEndCH378Cmd( );	
	
	/* ִдĿ¼ */
	return( CH378SendCmdWaitInt( CMD0H_LONG_DIR_CREATE ) );
}

/*******************************************************************************
* Function Name  : CH378OpenLongName
* Description    : ͨļļ
* Input          : PathName---ļĿ¼·
*                  LongName---UNICODEС˱˫0ĳļ
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 CH378OpenLongName( PUINT8 PathName, PUINT8 LongName ) 
{
	UINT8  status;	
	UINT16	count;

	/* ýҪĶļ· */	
	CH378SetFileName( PathName );  								 /* ýҪļĲ· */

	/* óļ */
	for( count = 0; count < LONG_NAME_BUF_LEN; count += 2 ) 
	{
		if ( *(PUINT16)( &LongName[ count ] ) == 0 ) 
		{
			break;  											 /* λ */
		}
	}
	if( ( count == 0 ) || ( count >= LONG_NAME_BUF_LEN ) || ( count > LONE_NAME_MAX_CHAR ) ) 
	{
		return( ERR_LONG_NAME_ERR );  							 /* ļЧ */
	}	
	count = count + 2;											 /* ļֽΪ0x00 */		
	xWriteCH378Cmd( CMD10_SET_LONG_FILE_NAME );					 /* д1ֽ */		
	xWriteCH378Data( ( UINT8 )count );							 /* д2ֽݳ */
	xWriteCH378Data( count >> 8 );							
	do
	{
		xWriteCH378Data( *LongName++ );
	}while( --count );		
	xEndCH378Cmd( );

	/* 򿪳ļӦļ */
	status = CH378SendCmdWaitInt( CMD0H_LONG_FILE_OPEN );
	return( status );	
}

/*******************************************************************************
* Function Name  : CH378EraseLongName
* Description    : ͨļɾļ
* Input          : PathName---ļĿ¼·
*                  LongName---UNICODEС˱˫0ĳļ
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 CH378EraseLongName( PUINT8 PathName, PUINT8 LongName ) 
{
	UINT8  status;	
	UINT16	count;

	/* ýҪĶļ· */	
	CH378SetFileName( PathName );  								 /* ýҪļĲ· */

	/* óļ */
	for( count = 0; count < LONG_NAME_BUF_LEN; count += 2 ) 
	{
		if ( *(PUINT16)( &LongName[ count ] ) == 0 ) 
		{
			break;  											 /* λ */
		}
	}
	if( ( count == 0 ) || ( count >= LONG_NAME_BUF_LEN ) || ( count > LONE_NAME_MAX_CHAR ) ) 
	{
		return( ERR_LONG_NAME_ERR );  							 /* ļЧ */
	}	
	count = count + 2;											 /* ļֽΪ0x00 */		
	xWriteCH378Cmd( CMD10_SET_LONG_FILE_NAME );					 /* д1ֽ */		
	xWriteCH378Data( ( UINT8 )count );							 /* д2ֽݳ */
	xWriteCH378Data( count >> 8 );							
	do
	{
		xWriteCH378Data( *LongName++ );
	}while( --count );		
	xEndCH378Cmd( );

	/* ɾļӦļ */
	status = CH378SendCmdWaitInt( CMD0H_LONG_FILE_ERASE );
	return( status );	
}


#endif

/**********************************************************************************************************/
/* Ϊǳ,ͨEN_OTHER_FUNCTIONرջ,ҲѡԵĿ */
/**********************************************************************************************************/

#ifdef	EN_OTHER_FUNCTION

/*******************************************************************************
* Function Name  : CH378GetICVer
* Description    : ȡCH378оƬ汾
* Input          : None
* Output         : None
* Return         : оƬ汾
*******************************************************************************/
UINT8 CH378GetICVer( void ) 
{
	UINT8  s;

	xWriteCH378Cmd( CMD01_GET_IC_VER );
	s = xReadCH378Data( );
	xEndCH378Cmd( );
	return( s );
}

/*******************************************************************************
* Function Name  : CH378HardwareReset
* Description    : ִCH378Ӳλ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH378HardwareReset( void ) 
{
	xWriteCH378Cmd( CMD00_RESET_ALL );
	xEndCH378Cmd( );
	mDelaymS( 50 );												 /* ȴλ */
}

/*******************************************************************************
* Function Name  : CH378EnterHalfSleep
* Description    : ʹCH378˯״̬
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH378EnterHalfSleep( void ) 
{
	xWriteCH378Cmd( CMD10_ENTER_SLEEP ); 
	xWriteCH378Data( HALF_SLEEP_MODE ); 						 /* ˯ģʽ */	
	xEndCH378Cmd( );
	mDelaymS( 50 );												 /* ȴ */
}

/*******************************************************************************
* Function Name  : CH378EnterFullSleep
* Description    : ʹCH378˯״̬
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH378EnterFullSleep( void ) 
{
	xWriteCH378Cmd( CMD10_ENTER_SLEEP ); 
	xWriteCH378Data( FULL_SLEEP_MODE ); 						 /* ˯ģʽ */	
	xEndCH378Cmd( );
	mDelaymS( 50 );												 /* ȴ */
}

/*******************************************************************************
* Function Name  : CH378CheckExist
* Description    : CH378ԼͨѶǷ
* Input          : None
* Output         : None
* Return         : ERR_SUCCESSʾCH378ԼͨѶ;
*                  ERR_USB_UNKNOWNʾ,Ҫ
*******************************************************************************/
UINT8 CH378CheckExist( void ) 
{
	UINT8  dat;

	xWriteCH378Cmd( CMD11_CHECK_EXIST );  						 /* ԵƬCH378֮ͨѶӿ */
	xWriteCH378Data( 0x78 );
	dat = xReadCH378Data( );
	xEndCH378Cmd( );
	if( dat != 0x87 ) 
	{
		/* ͨѶӿڲ,ԭ:ӿ쳣,豸Ӱ(ƬѡΨһ),ڲ,һֱڸλ,񲻹 */
		return( ERR_USB_UNKNOWN );  
	}
	else
	{
		return( ERR_SUCCESS );
	}	
}

/*******************************************************************************
* Function Name  : CH378ClearStall
* Description    : ˵
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 CH378ClearStall( UINT8 endp ) 
{
	return( CH378SendCmdDatWaitInt( CMD1H_CLR_STALL, endp ) );	 /* ʽ: ƴ-˵ */	
}

/*******************************************************************************
* Function Name  : CH378EnumDevice
* Description    : CH378ֶöUSB豸
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 CH378SelfEnumDevice( PUINT8 buf ) 
{
	UINT8  status;
	
	/* ȡ豸 */
	status = CH378SendCmdDatWaitInt( CMD1H_GET_DESCR, 0x01 );
	if( status != ERR_SUCCESS )
	{
		return( status );
	}
	status = CH378ReadReqBlock( buf );
	
	/* ɽ */

	/* õַ */
	status = CH378SendCmdDatWaitInt( CMD1H_SET_ADDRESS, 0x05 );
	if( status != ERR_SUCCESS )
	{
		return( status );
	}
	
	/* ȡ */
	status = CH378SendCmdDatWaitInt( CMD1H_GET_DESCR, 0x02 );
	if( status != ERR_SUCCESS )
	{
		return( status );
	}
	status = CH378ReadReqBlock( buf );

	/* ɽ */
	
	/* ֵ */
	status = CH378SendCmdDatWaitInt( CMD1H_SET_CONFIG, buf[ 5 ] );
	if( status != ERR_SUCCESS )
	{
		return( status );
	}
	return( status );		
}

/*******************************************************************************
* Function Name  : CH378AutoEnumDevice
* Description    : CH378Զö豸
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 CH378AutoEnumDevice( void ) 
{ 
	return( CH378SendCmdWaitInt( CMD0H_AUTO_SETUP ) );		
}

/*******************************************************************************
* Function Name  : CH378AutoInitDisk
* Description    : CH378ԶʼUSB洢
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 CH378AutoInitDisk( void ) 
{
	return( CH378SendCmdWaitInt( CMD0H_DISK_INIT ) );		
}

/*******************************************************************************
* Function Name  : CH378AutoResetDisk
* Description    : CH378λUSB洢
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 CH378AutoResetDisk( void ) 
{
	return( CH378SendCmdWaitInt( CMD0H_DISK_RESET ) );		
}

/*******************************************************************************
* Function Name  : CH378GetDiskSize
* Description    : CH378ȡUSB洢
* Input          : None
* Output         : buf---ݰ
*				   len---ݳ(һΪ8ֽ)
* Return         : None
*******************************************************************************/
UINT8 CH378GetDiskSize( PUINT8 buf, PUINT8 len ) 
{
	UINT8  status;
	
	status = CH378SendCmdWaitInt( CMD0H_DISK_SIZE );
	if( status != ERR_SUCCESS )
	{
		return( status );
	}
	*len = CH378ReadReqBlock( buf );
	return( status );
}	

/*******************************************************************************
* Function Name  : CH378GetDiskInquiry
* Description    : CH378ȡUSB洢
* Input          : None
* Output         : buf---ݰ
*				   len---ݳ(һΪ36ֽ)
* Return         : None
*******************************************************************************/
UINT8 CH378GetDiskInquiry( PUINT8 buf, PUINT8 len ) 
{
	UINT8  status;
	
	status = CH378SendCmdWaitInt( CMD0H_DISK_INQUIRY );
	if( status != ERR_SUCCESS )
	{
		return( status );
	}
	*len = CH378ReadReqBlock( buf );
	return( status );	
}	

/*******************************************************************************
* Function Name  : CH378GetDiskReady
* Description    : CH378USB洢Ƿ׼
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 CH378GetDiskReady( void ) 
{
	UINT8  status;
	
	status = CH378SendCmdWaitInt( CMD0H_DISK_READY );
	if( status != ERR_SUCCESS )
	{
		return( status );
	}
	return( status );	
}	

/*******************************************************************************
* Function Name  : CH378GetDiskReqSense
* Description    : CH378USB洢
* Input          : None
* Output         : buf---ݰ
*				   len---ݳ
* Return         : None
*******************************************************************************/
UINT8 CH378GetDiskReqSense( PUINT8 buf, PUINT8 len ) 
{
	UINT8  status;
	
	status = CH378SendCmdWaitInt( CMD0H_DISK_R_SENSE );
	if( status != ERR_SUCCESS )
	{
		return( status );
	}
	*len = CH378ReadReqBlock( buf );
	return( status );
}	

/*******************************************************************************
* Function Name  : CH378BlockOnlyCMD
* Description    : CH378ִBulkOnlyЭ
* Input          : buf---ҪִеBulkOnly; 
* Output         : buf---ִBulkOnlyݰ
*                  len---ݰ  
* Return         : None
*******************************************************************************/
UINT8 CH378BlockOnlyCMD( PUINT8 buf, PUINT8 len ) 
{
	UINT8  status;

	/* ͨCMD40_WR_HOST_OFS_DATAдCBW */	
	CH378WriteOfsBlock( buf, 0x00, 31 );
	
	/* ٷ */
	status = CH378SendCmdWaitInt( CMD0H_DISK_BOC_CMD );
	if( status != ERR_SUCCESS )
	{
		return( status );
	}

	/* ݷ,ȡ */
	*len = CH378ReadReqBlock( buf );
	return( status );
}		

#endif
